package org.supermarket.gr;

import android.app.Activity;
import android.content.res.Resources;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.BaseExpandableListAdapter;
import android.widget.ExpandableListAdapter;
import android.widget.TextView;

/**
 * Η κλαση αυτή είναι υπεύθυνη για τον υπολογισμό του κόστους, της λίστας που επιλέχτηκε από το χρήστη για κάθε κοντινό supermarket.
 */
public class AllSupermarketPrices extends Activity{

    ExpandableListAdapter mAdapter;
    protected String[] supermarketsNameAndAddress;
    protected String[][] productPrices;
	protected Resources res;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.all_prices);

        
        res = getResources();
        productPrices=new String[SupermarketsAndPricesStaticClass.getProductsAndPrices().length][];
        for(int i=0;i<SupermarketsAndPricesStaticClass.getProductsAndPrices().length;i++)
        {
        	productPrices[i]=new String[SupermarketsAndPricesStaticClass.getProductsAndPrices()[i].length];
        	for(int j=0;j<SupermarketsAndPricesStaticClass.getProductsAndPrices().length;j++)
            {
        		productPrices[i][j]=SupermarketsAndPricesStaticClass.getProductsAndPrices()[i][j];
            }
        }
       
        supermarketsNameAndAddress=new String[SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress().length];
        for(int i=0;i<SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress().length;i++)
        {
        	supermarketsNameAndAddress[i]=SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress()[i];
        }
        supermarketsNameAndAddress=SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress();
        
        
    	//presentItems();
    }

    
    public class MyExpandableListAdapter extends BaseExpandableListAdapter
    {
        public Object getChild(int groupPosition, int childPosition) {
            return productPrices[groupPosition][childPosition];
        }

        public long getChildId(int groupPosition, int childPosition) {
            return childPosition;
        }

        public int getChildrenCount(int groupPosition) {
            return productPrices[groupPosition].length;
        }

        public TextView getGenericViewGroups() {
            // Layout parameters for the ExpandableListView
            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

            TextView textView = new TextView(AllSupermarketPrices.this);
            textView.setLayoutParams(lp);
            // Center the text vertically
            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
            // Set the text starting position
            textView.setTextColor(res.getColor(R.color.expandable_text_color_groups));
            textView.setBackgroundColor(res.getColor(R.color.blue_text));
            textView.setPadding(36, 0, 0, 0);
            return textView;
        }
        
        public TextView getGenericViewChilds() {
            // Layout parameters for the ExpandableListView
            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

            TextView textView = new TextView(AllSupermarketPrices.this);
            textView.setLayoutParams(lp);
            // Center the text vertically
            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
            // Set the text starting position
            textView.setTextColor(res.getColor(R.color.expandable_text_color_childs));
            textView.setBackgroundColor(res.getColor(R.color.expandable_childs));
            textView.setPadding(36, 0, 0, 0);
            return textView;
        }
        
        public View getChildView(int groupPosition, int childPosition, boolean isLastChild,View convertView, ViewGroup parent) 
        {
            TextView textView = getGenericViewChilds();
            textView.setText(getChild(groupPosition, childPosition).toString());
            return textView;
        }

        public Object getGroup(int groupPosition) 
        {
            return supermarketsNameAndAddress[groupPosition];
        }

        public int getGroupCount() 
        {
            return supermarketsNameAndAddress.length;
        }

        public long getGroupId(int groupPosition) 
        {
            return groupPosition;
        }

        public View getGroupView(int groupPosition, boolean isExpanded, View convertView,ViewGroup parent)
        {
            TextView textView = getGenericViewGroups();
            textView.setText(getGroup(groupPosition).toString());
            return textView;
        }

        public boolean isChildSelectable(int groupPosition, int childPosition) 
        {
            return true;
        }

        public boolean hasStableIds()
        {
            return true;
        }

    }

   
}