package org.supermarket.gr;

import java.io.IOException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.util.Log;

/**
 * Στη κλάση αυτή πραγματοποιείται επικοινωνία με τον server ώστε να διαπιστωθεί η ύπαρξη ή οχι
 * ενος συγκεκριμένου barcode στη βάση δεδομένων.
 */

public class BarcodeExistsInDB extends AsyncTask<String, Void,Integer>
{
	private Activity activityContext;
	/**
	 * Boolean Μετάβλητη για την ύπαρξη Internet συνδεσης
	 */
	protected boolean hasInternet;
	protected String barcodeUrl="http://supermarket.flexmarket.biz/database/barcode_exist.php";
	protected ProgressDialog dialogDB;
	/**
	 * Πίνακας με τα στοιχεία του προιόντος
	 */
	protected String barcodeDetails[];
	/**
	 * Αντικείμενο τύπου DatabaseCommunication
	 */
	protected DatabaseCommunication ed;
	private final int SET_QUANTITIES_REQUEST_CODE=120;
	private final int ADD_BARCODE_REQUEST_CODE=121;
	/**
	 * Το barcode του προιόντος
	 */
	private String barcodeUpc;
	/**
	 * Μεταβλητή απο τη τιμή της οποίας εξαρτάται το τι ενέργειες θα ακολουθήσουν μετά την ολοκλήρωση της επικοινωνίας
	 */
	private String caseOfSearch;
	/**
	 * Μεταβλητή που χρησιμοποιείται για τη διάκριση της περίπτωσης προσθηκης και αφαίρεσης προίοντος
	 */
	private String caseOfScan;
	
	
	public BarcodeExistsInDB(Activity context,String theUpc,String caseSearch) 
	{
		activityContext = context;
		barcodeUpc=new String(theUpc);
		caseOfSearch=new String(caseSearch);
	}
	
	public BarcodeExistsInDB(Activity context,String theUpc,String caseSearch,String caseScan) 
	{
		activityContext = context;
		barcodeUpc=new String(theUpc);
		caseOfSearch=new String(caseSearch);
		caseOfScan=new String(caseScan);
	}
	
	/**
	 * Τροποποιεί (μειώνει ή αυξάνει) τη ποσότητα ενος προιόντος στο ψυγείο
	 */
	public void addOrRemoveFromFridge(String barcodeUpc)
	{
		DatabaseCommunication ed1=new DatabaseCommunication(activityContext);
		if(caseOfScan.equals("add"))
    	{
			ed1.removeOrAddProductAmount("add",barcodeUpc,"1");
    		
    	}
    	else if(caseOfScan.equals("remove"))
    	{
    		ed1.removeOrAddProductAmount("remove",barcodeUpc,"1");
    	}
		ed1.closeDB();
	}
	
	/**
     * Ελέγχει για ενεργή σύνδεση με το Internet. 
     * Αν υπάρχει σύνδεση επιστρέφει true
    */
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) activityContext.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}
	
    /**
     * Αρχικοποιήσεις και αλλαγές στο main thread ακριβώς πριν ξεκινήσει το child thread να εκτελείται
    */
	@Override
	 protected void onPreExecute()
	 {
		ed=new DatabaseCommunication(activityContext);
		dialogDB = new ProgressDialog(activityContext);
		dialogDB = ProgressDialog.show(activityContext,activityContext.getResources().getText(R.string.wait_please),activityContext.getResources().getText(R.string.test_database), true);
		hasInternet=isOnline();
	 }
	
	/**
     * Tο child thread ξεκίνησε την επεξεργασία.
    */
	@Override
	protected Integer doInBackground(String... urls)
	{
		if(hasInternet==true)
 	  	{
			try 	
			{
       	    	barcodeUrl=barcodeUrl+"?barcode="+barcodeUpc;
       	    	
       	    	Log.v("TAG barcode url","barcode url : " +barcodeUrl);
       	    	
       	    	HttpClient client= new DefaultHttpClient();
       	    	StringBuilder url=new StringBuilder(barcodeUrl);
				HttpGet getHttp=new HttpGet(url.toString());
				
				HttpResponse responseHttp = client.execute(getHttp);
				int status=responseHttp.getStatusLine().getStatusCode();
				if(status==200)
				{
					HttpEntity e=responseHttp.getEntity();
					String data =EntityUtils.toString(e);
					JSONArray	jsonData = new JSONArray("["+data+"]");
					JSONObject jsonObjects = null;
					jsonObjects =jsonData.getJSONObject(0);
					
					barcodeDetails=new String [7];
					
					int countRows=Integer.parseInt(jsonObjects.getString("total_rows"));
					
					JSONObject last=null;
					last =jsonData.getJSONObject(0);
					if(countRows==0)
					{
						Log.v("TAG barcode url","2 : To prooion de vrethike ston server");
						//To prooion de vrethike ston server
						return 2;
					}
					else
					{
						JSONArray content = null;
						content =last.getJSONArray("content");
						
						for (int i = 0; i < countRows; i++) 
					    {
							JSONObject last3 = null;
							last3=(JSONObject) content.get(i);
							
							if(last3.isNull("barcode"))
								barcodeDetails[0]="null";
							else
								barcodeDetails[0]=last3.getString("barcode");
							
							if(last3.isNull("name"))
								barcodeDetails[1]="null";
							else
								barcodeDetails[1]=last3.getString("name");
							
							if(last3.isNull("items"))
								barcodeDetails[2]="null";
							else
								barcodeDetails[2]=last3.getString("items");
							
							if(last3.isNull("weight"))
								barcodeDetails[3]="null";
							else
								barcodeDetails[3]=last3.getString("weight");
							
							if(last3.isNull("unit_id"))
								barcodeDetails[4]="null";
							else
								barcodeDetails[4]=last3.getString("unit_id");
							
							if(last3.isNull("br_id"))
								barcodeDetails[5]="null";
							else
								barcodeDetails[5]=last3.getString("brand_id");
							
							if(last3.isNull("packed"))
								barcodeDetails[6]="null";
							else
								barcodeDetails[6]=last3.getString("packed");
					    }
						
						Log.v("TAG barcode url","1 : To prooion  vrethike ston server");
						return 1;
					}
					
					
					
				}
				else 
				{
					Log.v("TAG barcode url","3 : error");
					return 3;
				}
			} 
			catch (ClientProtocolException e1) 
			{
				Log.v("TAG barcode url","3 : error");
				e1.printStackTrace();
				return 3;
			} 
			catch (IOException e1) 
			{
				Log.v("TAG barcode url","3 : error");
				e1.printStackTrace();
				return 3;
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				Log.v("TAG barcode url","3 : error");
				e.printStackTrace();
				return 3;
			} 
			
 	  	}
		else 
		{
			Log.v("TAG barcode url","4 : no internet");
			return 4;
		}
			
	}
	
	/**
     * Περίπτωση απρόσμενης διακοπής του child thread
    */
	@Override
    protected void onCancelled() 
	{
		dialogDB.dismiss();
		ed.closeDB();
    }

	/**
     * Το child thread ολοκλήρωσε την επεξεργασία. Αλλαγές στο main thread
    */
	@Override
    protected void onPostExecute(Integer result)
    {
		/**
		 * Result 4 means that there is no internet connection and as a result the communication with the server is not available.
		 * Result 3 means that an error-exception occur during the communication with the server
		 * 
		 * At both these cases we will check if the barcode we scan before is already in the products table. If exists in products table
		 * nothing will happen. If does not exists we will store the product locally and set the value is_stored_to_server to false
		 */
    	if(result==4 || result==3)
    	{
            Cursor cursor =ed.retrieveSpecificProduct(barcodeUpc);
            if(cursor.getCount()==0)
            {
            	Intent addBarcode=new Intent(activityContext,NewBarcodeUI.class);
				  addBarcode.putExtra("barcode",barcodeUpc);
				  addBarcode.putExtra("productName","nil");
				  addBarcode.putExtra("amount","nil");
				  addBarcode.putExtra("productIsPackedItems","nil");
				  addBarcode.putExtra("unitsId","nil");
				  addBarcode.putExtra("brandsId","nil");
				  activityContext.startActivityForResult(addBarcode,ADD_BARCODE_REQUEST_CODE);
            }
           
    	
    	}
    	/**
		 * Result 1 means that the communication with the server was successful and the product exists at server.
		 * 
		 */
    	else if(result==1)
    	{
    		if(caseOfSearch.equals("ChangeProductsFridgeQuantity"))
    		{
	    		Cursor theCursor= ed.retrieveSpecificProduct(barcodeUpc);
    			if(theCursor.getCount()==0)
    				ed.storeProductsLocally(barcodeDetails[1],barcodeUpc,barcodeDetails[6],barcodeDetails[3],barcodeDetails[2],barcodeDetails[4],barcodeDetails[5],"true");
    	    	
    			ed.closeDB();
    			theCursor.close();
    			
            	
    			//addOrRemoveFromFridge(barcodeUpc);
    		}
    		else
    		{
    			Cursor theCursor= ed.retrieveSpecificProduct(barcodeUpc);
    			if(theCursor.getCount()==0)
    				ed.storeProductsLocally(barcodeDetails[1],barcodeUpc,barcodeDetails[6],barcodeDetails[3],barcodeDetails[2],barcodeDetails[4],barcodeDetails[5],"true");
    	    	
    			
    			theCursor.close();
    			
    			if(caseOfSearch.equals("NewShoppingList"))
        		{
    				Intent quantities = new Intent(activityContext,QuantitiesOfProductInList.class);
                	quantities.putExtra("barcodescanned",barcodeUpc);
                	quantities.putExtra("origin","list");
                	activityContext.startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
        		}
    			else if(caseOfSearch.equals("ManageFridge"))
        		{
    				Intent quantities = new Intent(activityContext,ManageFridgeDatabaseStore.class);
                	quantities.putExtra("barcodescanned",barcodeUpc);
                	quantities.putExtra("origin","managefridge");
                	activityContext.startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
        		}
    			else if(caseOfSearch.equals("UserProductLists"))
        		{
    				Intent quantities = new Intent(activityContext,QuantitiesOfProductInList.class);
                	quantities.putExtra("barcodescanned",barcodeUpc);
                	quantities.putExtra("origin","lists");
                	activityContext.startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
        		}
    			
    		}
    		
    		
		}
    	/**
		 * Result 2 means that the communication with the server was successful but the product does not exist at server.
		 * This means that we will try to add the product both to localy database and to the server
		 * 
		 */
    	else if(result==2)
    	{
    		Intent addBarcode=new Intent(activityContext,NewBarcodeUI.class);
			  addBarcode.putExtra("barcode",barcodeUpc);
			  addBarcode.putExtra("productName","nil");
			  addBarcode.putExtra("amount","nil");
			  addBarcode.putExtra("productIsPackedItems","nil");
			  addBarcode.putExtra("unitsId","nil");
			  addBarcode.putExtra("brandsId","nil");
			  activityContext.startActivityForResult(addBarcode,ADD_BARCODE_REQUEST_CODE);
    	}
    	
    	ed.closeDB();
    	dialogDB.dismiss();
    }

}