package org.supermarket.gr;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;
/**
 * Σχεδιάζει το γραφικό περιβάλλον για την ενημέρωση των ποσοτήτων των προϊόντων του ηλεκτρονικού ψυγείου.  
 **/
public class ChangeProductsFridgeQuantity extends Activity implements OnClickListener 
{
	protected Button addToBasket;
	protected Button addToShoppingList;
	protected String upc;
	protected String textFormat;
	protected String caseOfScan;
	private final int ADD_BARCODE_REQUEST_CODE=121;
	private final int SET_QUANTITIES_REQUEST_CODE=120;
	
	@Override
    public void onCreate(Bundle savedInstanceState) 
    {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.barcode);
		caseOfScan=new String();
		
		addToBasket=(Button) findViewById(R.id.add_to_fridge_bt);
		addToBasket.setOnClickListener(this);
		
		addToShoppingList=(Button) findViewById(R.id.remove_from_fridge_bt);
		addToShoppingList.setOnClickListener(this);
		
    }
	
	public void onClick(View v) 
	{
		 switch(v.getId())
	      {
		     case R.id.add_to_fridge_bt:
		    	 	caseOfScan="add";
		    	 	IntentIntegrator integrator = new IntentIntegrator(this);
		 			integrator.initiateScan();
		 			break;
		     case R.id.remove_from_fridge_bt:
		    	 	caseOfScan="remove";
		    	 	IntentIntegrator integrator1 = new IntentIntegrator(this);
		 			integrator1.initiateScan();
			    	 break;
		    
	   }
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{
	
		switch (requestCode) 
        {
	        case ADD_BARCODE_REQUEST_CODE:
	        	if(resultCode == RESULT_OK) 
				{
	        		Intent quantities = new Intent(this,QuantitiesOfProductInList.class);
		        	quantities.putExtra("barcodescanned",upc);
		        	quantities.putExtra("origin","fridge");
				    startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
				    
		        }
		        else
		        	Toast.makeText(this,R.string.edit_barcode_fields_p,Toast.LENGTH_SHORT).show();
		        
	        	break;
	        case SET_QUANTITIES_REQUEST_CODE: 
	        	if(resultCode == RESULT_OK) 
				{
	        		Bundle extras = intent.getExtras();
	        		DatabaseCommunication ed=new DatabaseCommunication(this);
	    	        if(extras != null)
	    	        {
	    	        	
			        	if(caseOfScan.equals("add"))
			        	{
			        		ed.removeOrAddProductAmount("add",upc,extras.getString("quantityKey"));
			        	}
			        	else if(caseOfScan.equals("remove"))
			        	{
			        		ed.removeOrAddProductAmount("remove",upc,extras.getString("quantityKey"));
			        	}
	    	        }
	    	        else
	    	        {
			        	if(caseOfScan.equals("add"))
			        	{
			        		ed.removeOrAddProductAmount("add",upc,"1");
			        	}
			        	else if(caseOfScan.equals("remove"))
			        	{
			        		ed.removeOrAddProductAmount("remove",upc,"1");
			        	}
	    	        }
	        		
		        	ed.closeDB();
				}
	        	
	        default:
	        	IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, intent);
	  		  if (scanResult != null) 
	  		  {
	  			  upc = scanResult.getContents();
	  			  
	  			
	  					  if(resultCode == RESULT_OK) 
	  					  {
	  						  BarcodeExistsInDB task = new BarcodeExistsInDB(this,upc,"ChangeProductsFridgeQuantity",caseOfScan);
	  						  task.execute(new String[] { "" });
	  						  Intent quantities = new Intent(this,QuantitiesOfProductInList.class);
	  						  quantities.putExtra("barcodescanned",upc);
	  						  quantities.putExtra("origin","fridge");
	  						  startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
	  						  
	  						  
	  					  }
	  					  else if(resultCode == RESULT_CANCELED)
	  						  Toast.makeText(ChangeProductsFridgeQuantity.this,R.string.scan_cancelled,Toast.LENGTH_SHORT).show();
	  					  
	  		  }
	  		  //else 
	  			  //Toast.makeText(ChangeProductsFridgeQuantity.this,R.string.upc_null,Toast.LENGTH_LONG).show();
			break;
        }
		
	}
   
}
