package org.supermarket.gr;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

/**
 * Στη κλαση αυτή αρχικοποιείται η επικοινωνία με τη κεντρική βάση δεδομένων και καλούνται οι web υπηρεσίες που είναι υπεύθυνες για την δημιουργία νέου λογαριασμού χρήστη.
 */
public class CreateUserAccountCommunicate extends AsyncTask<String, Void,Integer>
{
	private Activity activityContext;
	protected ProgressDialog dialogDB;
	public static final String USER_STORED = "User_stored";
	protected boolean online;
	//protected HttpGet get;
	protected HttpPost post;
	protected HttpResponse r;
	protected int status;
	HttpClient client;
	StringBuilder url;
	protected String insertUser;
	JSONObject jsonObjects = null;
	JSONArray last2 = null;
	JSONObject last3=null;
	private String details[];
	
	protected String usersUsername;
	protected String usersPassword;
	protected String usersEmail;
	protected String usersBirthday;
	protected String usersSex;
	protected String usersAddress;
	
	public CreateUserAccountCommunicate(Activity context,String theUsername,String thePassword,String theEmail,String theBirthday,String theAddress,String theSex) 
	{
		activityContext = context;
		usersUsername=new String(theUsername);
		usersPassword=new String(thePassword);
		usersEmail=new String(theEmail);
		usersBirthday=new String(theBirthday);
		usersAddress=new String(theAddress);
		usersSex=new String(theSex);
	}
	
	
	/**
     * Ελέγχει για ενεργή σύνδεση με το Internet. 
     * Αν υπάρχει σύνδεση επιστρέφει true
    */
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) activityContext.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}
	
    /**
     * Αρχικοποιήσεις και αλλαγές στο main thread ακριβώς πριν ξεκινήσει το child thread να εκτελείται
    */
	@Override
	 protected void onPreExecute()
	 {
		//insertUser="http://supermarket.flexmarket.biz/json/insert_user.php?username="+newUsername.getText().toString()+"&password="+newPassword.getText().toString()+"&email="+newEmail.getText().toString()+"&birthday="+newBirthday.getText().toString()+"&address="+newAddress.getText().toString()+"&sex="+newSex;
		insertUser="http://supermarket.flexmarket.biz/json/insert_user.php";
		dialogDB = new ProgressDialog(activityContext);
		dialogDB = ProgressDialog.show(activityContext,activityContext.getResources().getText(R.string.wait_please),activityContext.getResources().getText(R.string.test_database), true);
		online=isOnline();
	 }
	
	/**
     * Tο child thread ξεκίνησε την επεξεργασία.
    */
	@Override
	protected Integer doInBackground(String... urls)
	{
		if(online==true)
  	  	{
    	    try 
			{
		    	client= new DefaultHttpClient();
				url=new StringBuilder(insertUser);
				post=new HttpPost(url.toString());
				//get=new HttpGet(url.toString());
				
				List<NameValuePair> value=new ArrayList<NameValuePair>();
		        value.add(new BasicNameValuePair("username",usersUsername));
		        value.add(new BasicNameValuePair("password",usersPassword));
		        value.add(new BasicNameValuePair("email",usersEmail));
		        value.add(new BasicNameValuePair("birthday",usersBirthday));
		        value.add(new BasicNameValuePair("address",usersAddress));
		        value.add(new BasicNameValuePair("sex",usersSex));
	 
		        UrlEncodedFormEntity entity=new UrlEncodedFormEntity(value);
	 
		        post.setEntity(entity);
	 
		      //  client.execute(request);
				
				r = client.execute(post);
				status=r.getStatusLine().getStatusCode();
				if(status==200)
				{
					HttpEntity e=r.getEntity();
					String data =EntityUtils.toString(e);
					JSONArray	jsonData = new JSONArray("["+data+"]");
					jsonObjects =jsonData.getJSONObject(0);
					
					int countRows=Integer.parseInt(jsonObjects.getString("total_rows"));
					
				
					if(countRows==0)
					{
						return 2;
					}
					else if(countRows==-1)
					{
						return 4;
					}
					else
					{
						details=new String[7];
						JSONArray content =jsonObjects.getJSONArray("content");
						
							last3=(JSONObject) content.get(0);
						
							
							if(last3.isNull("username"))
								details[0]="null";
							else
								details[0]=last3.getString("username");
							
							if(last3.isNull("password"))
								details[1]="null";
							else
								details[1]=last3.getString("password");
							
							if(last3.isNull("email"))
								details[2]="null";
							else
								details[2]=last3.getString("email");
						
							if(last3.isNull("birthday"))
								details[3]="null";
							else
								details[3]=last3.getString("birthday");
							
							if(last3.isNull("address"))
								details[4]="null";
							else
								details[4]=last3.getString("address");
							
							if(last3.isNull("sex"))
								details[5]="null";
							else
								details[5]=last3.getString("sex");
							
							int idNum=last3.getInt("id");
							details[6]=Integer.toString(idNum);
							
							return 1;
							
					}
					
					
			
				}
				else
					return 3;
			} 
			catch (ClientProtocolException e1) 
			{
				
				
				return 3;
			} 
			catch (IOException e1) 
			{
				
				
				return 3;
			}
    	    catch (JSONException e) {
				// TODO Auto-generated catch block
				return 3;
			} 
			
  	  	}
		else 
			return 0;
			
	}
	
	/**
     * Περίπτωση απρόσμενης διακοπής του child thread
    */
	@Override
    protected void onCancelled() 
	{
		dialogDB.dismiss();
    }

	/**
     * Το child thread ολοκλήρωσε την επεξεργασία. Αλλαγές στο main thread
    */
	@Override
    protected void onPostExecute(Integer result)
    {

    	if(result==1)
		{
    		DatabaseCommunication ed=new DatabaseCommunication(activityContext);
			ed.insertNewUser(details[6],usersUsername,usersPassword,usersEmail,usersBirthday,usersAddress,usersSex);
			
			
			ed.closeDB();
			
			SharedPreferences user = activityContext.getSharedPreferences(USER_STORED, 0);
 		    SharedPreferences.Editor editor = user.edit();
 			editor.putString("username", usersUsername);
 			editor.putString("password",usersPassword);
 			editor.putString("user_id",details[6]);
 			editor.commit();
 			
 			
 			
 			Intent firstActivity = new Intent(activityContext,MainActivityUI.class);
 			activityContext.startActivity(firstActivity);
 			activityContext.finish();
			
			
		}
    	else if(result==0)
    	{
    		Toast.makeText(activityContext,R.string.no_internet,Toast.LENGTH_LONG).show();
    	}
    	else if(result==3)
    	{
    		Toast.makeText(activityContext,R.string.network_error,Toast.LENGTH_LONG).show();
    		Toast.makeText(activityContext,R.string.network_error_sol,Toast.LENGTH_LONG).show();
    	}
    	else if(result==2)
    	{
    		Toast.makeText(activityContext,R.string.new_account_error_database,Toast.LENGTH_LONG).show();
    		Toast.makeText(activityContext,R.string.network_error_sol,Toast.LENGTH_LONG).show();
    	}
    	else if(result==4)
    	{
    		Toast.makeText(activityContext,R.string.new_account_error_already_exists,Toast.LENGTH_LONG).show();
    		Toast.makeText(activityContext,R.string.network_error_sol,Toast.LENGTH_LONG).show();
    	}
    	dialogDB.dismiss();
    //	threadCompleted();
    
    }

}