/**
 * @author  Petros Melissaridis
 * @version 1.0
 * @see     java.awt.BaseWindow
 * @see     java.awt.Button
 */

package org.supermarket.gr;

import java.util.Calendar;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.res.Resources;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;

/**
 * Στην CreateUserAccountUI σχεδιάζεται το GUI για την δημιουργία νέου λογαριασμού χρήστη. Επίσης πραγματοποιούνται διάφοροι έλεγχοι εγκυρότητας των στοιχείων που ορίζει ο χρήστης στη φόρμα αποστολής. 
 */
public class CreateUserAccountUI extends Activity implements OnClickListener
{
	//protected Resources res;
	//protected DatabaseCommunication ed;
	//protected ProgressDialog dialogDB;
	protected EditText newUsername;
	protected EditText newPassword;
	protected EditText newRepeatPassword;
	protected EditText newEmail;
	protected  DatePicker dateBirthdayPicker;
	protected EditText newBirthday;
	protected EditText newAddress;
	protected String newSex;
	
	protected int year;
	protected int month;
	protected int day;
	protected Spinner userSex;
	
	static final int DATE_DIALOG_ID = 999;
	public static final String USER_STORED = "User_stored";
	protected Button accountButton;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.new_account);
		
		setActions();
		
	}
	
	/**
	 *  Αρχικοποίηση μεταβλητών και αντικειμένων
	 *
	 */
	void setActions()
	{
		
		accountButton=(Button) findViewById(R.id.new_account_button);
		accountButton.setOnClickListener(this);
        newUsername=(EditText) findViewById(R.id.new_username);
        newPassword=(EditText) findViewById(R.id.new_password);
        newRepeatPassword=(EditText) findViewById(R.id.repeat_password);
        newEmail=(EditText) findViewById(R.id.new_email);
        newBirthday=(EditText) findViewById(R.id.new_birthday);
        newBirthday.setOnClickListener(this);
        
        newAddress=(EditText) findViewById(R.id.new_address);
       // newSex=(EditText) findViewById(R.id.new_sex);
        newSex=new String("m");
        
        userSex = (Spinner) findViewById(R.id.new_sex);
		// Create an ArrayAdapter using the string array and a default spinner layout
		ArrayAdapter<CharSequence> adapterUnits = ArrayAdapter.createFromResource(this, R.array.new_sex, android.R.layout.simple_spinner_item);
		// Specify the layout to use when the list of choices appears
		adapterUnits.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		// Apply the adapter to the spinner
		userSex.setAdapter(adapterUnits);
		//spinnerUnits.setOnItemSelectedListener(this);
		
		userSex.setOnItemSelectedListener(new OnItemSelectedListener() 
  		  {

			public void onItemSelected(AdapterView<?> parent, View view,  int pos, long id)
			{
				// TODO Auto-generated method stub
				 if(pos==0)
		    	 {
		    		 newSex="m";
		    	 }
		    	 else if(pos==1)
		    	 {
		    		 newSex="f";
		    	 }
				
			}

			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub
				
			}
  			  
  		  }
  		  );
	}
	/*
	 * Date for birthday
	 */
	
	/**
	 *  Αρχικοποίηση μεταβλητής που κρατάει την τρέχουσα ημερομηνία
	 *
	 */
	public void setCurrentDateOnView() 
	{
 
		final Calendar c = Calendar.getInstance();
		year = c.get(Calendar.YEAR);
		month = c.get(Calendar.MONTH);
		day = c.get(Calendar.DAY_OF_MONTH);
 
	}
	
	
	@Override
	protected Dialog onCreateDialog(int id) 
	{
			switch (id)
			{
				case DATE_DIALOG_ID:
			   // set date picker as current date
					
					return new DatePickerDialog(this, datePickerListener, year, month,day);
			}
			return null;
	}

	
	private DatePickerDialog.OnDateSetListener datePickerListener = new DatePickerDialog.OnDateSetListener() 
	{

		// when dialog box is closed, below method will be called.
		public void onDateSet(DatePicker view, int selectedYear,int selectedMonth, int selectedDay) 
		{
			year = selectedYear;
			month = selectedMonth+1;
			day = selectedDay;
			
			System.out.println("year : " + year+" month : "+month +" day : "+day);
			String dateBirthday=new String();
			dateBirthday=Integer.toString(year)+"-"+Integer.toString(month)+"-"+Integer.toString(day);
			newBirthday.setText(dateBirthday);
		}
	};
	
	
	

	/**
     * Συλλογή των επιλογών των χρηστών και πραγματοποίηση των αντίστοιχων event.
     *  Έλεγχος της μορφας για λάθη του χρήστη (email validation, μη εισαγωγή λευκών χαρακτήρων
     *  , υποχρωτική στμπλήρωση των email, username and password,
     * σωστή επανάληψη κωδικού) 
     * 
    */
	public void onClick(View v) 
	{
		 switch(v.getId())
	      {
	      		case R.id.new_birthday:
	      			// Intent birthdayDateActivity = new Intent(getApplicationContext(),BirthdayPicker.class);
	                // startActivity(birthdayDateActivity);
	      			setCurrentDateOnView();
	      			showDialog(DATE_DIALOG_ID);
	      			break;
			     case R.id.new_account_button:
			 		accountButton=(Button) findViewById(R.id.new_account_button);
			 		accountButton.setOnClickListener(this);
			         newUsername=(EditText) findViewById(R.id.new_username);
			         newPassword=(EditText) findViewById(R.id.new_password);
			         newRepeatPassword=(EditText) findViewById(R.id.repeat_password);
			         newEmail=(EditText) findViewById(R.id.new_email);
			         newBirthday=(EditText) findViewById(R.id.new_birthday);
			         newAddress=(EditText) findViewById(R.id.new_address);
			       //  newSex=(EditText) findViewById(R.id.new_sex);
			         
			        
			         Matcher matcherUsername;
			         Matcher matcherPassword;
			         Matcher matcherRepeatPassword;
			        // Matcher matcherSex;
			         Matcher matcherEmail;
			         Matcher matcherBirthday;
			         Matcher matcherAddress;
			         
			         
			         Pattern pattern1 = Pattern.compile("\\s");
			         matcherUsername = pattern1.matcher((CharSequence) newUsername.getText().toString());
			         matcherPassword = pattern1.matcher((CharSequence) newPassword.getText().toString());
			         matcherRepeatPassword = pattern1.matcher((CharSequence) newRepeatPassword.getText().toString());
			       //  matcherSex = pattern1.matcher((CharSequence) newSex.getText().toString());
			         matcherEmail = pattern1.matcher((CharSequence) newEmail.getText().toString());
			         matcherBirthday = pattern1.matcher((CharSequence) newBirthday.getText().toString());
			         matcherAddress = pattern1.matcher((CharSequence) newAddress.getText().toString());

			    	 
			    	 if(!matcherUsername.find() && !matcherPassword.find() && !matcherRepeatPassword.find() && !matcherEmail.find() && !matcherBirthday.find() && !matcherAddress.find())
			    	 {
			    	 		String theUsername=newUsername.getText().toString();
			    	 		String thePassword=newPassword.getText().toString();
			    	 		String theRepeatPassword=newRepeatPassword.getText().toString();
			    	 		String theEmail=newEmail.getText().toString();
			    	 		String theBirthday=newBirthday.getText().toString();
			    	 		String theAddress=newAddress.getText().toString();
			    	 		String theSex=newSex;
			    	 	
			    	 	if(theUsername!=null && theUsername.length()>0 &&  theRepeatPassword!=null &&  thePassword!=null && thePassword.length()>0 &&  theEmail!=null && theEmail.length()>0)
				    	 {
			    	 		if(!isEmailValid(theEmail))
			    	 			Toast.makeText(this,R.string.not_valid_email,Toast.LENGTH_LONG).show();
			    	 		else if(!thePassword.equals(theRepeatPassword))
			    	 			Toast.makeText(this,R.string.not_same_paswd,Toast.LENGTH_LONG).show();
			    	 		else
			    	 		{
			    	 			CreateUserAccountCommunicate task = new CreateUserAccountCommunicate(this,theUsername,thePassword,theEmail,theBirthday,theAddress,theSex);
					    	     task.execute(new String[] { "" });
			    	 		}
				    	 }
			    		 else
			    		 {
			    			 Toast.makeText(this,R.string.field_not_edit,Toast.LENGTH_LONG).show();
			    		 }
			    	 }
			    	 else
			    	 {
			    		 Toast.makeText(this,R.string.no_white_characters,Toast.LENGTH_LONG).show();
			    	 }
			    	 break;
			    
	      }
	}
	
	
	/**
     * Function  email validation
     * 
    */
	public static boolean isEmailValid(String email) 
	{
	    boolean isValid = false;

	    String expression = "^[\\w\\.-]+@([\\w\\-]+\\.)+[A-Z]{2,4}$";
	    CharSequence inputStr = email;

	    Pattern pattern = Pattern.compile(expression, Pattern.CASE_INSENSITIVE);
	    Matcher matcher = pattern.matcher(inputStr);
	    if (matcher.matches()) {
	        isValid = true;
	    }
	    return isValid;
	}
	
	
}
