package org.supermarket.gr;


import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;
import android.widget.Toast;


	public class DatabaseCommunication 
	{	
		private SQLiteDatabase db;
		private Context context;
		private HelpDatabase myDb;
		private static final int CONFLICT_ABORT = 2;
		protected Resources res;
		
		//private SQLiteStatement insertStmt;
		
		public DatabaseCommunication(Context context) 
		{
			this.context = context;
		    myDb= new HelpDatabase(this.context);
		    this.db = myDb.getWritableDatabase();
		    res = context.getResources();
		     // this.insertStmt = this.myDb.compileStatement(INSERT);
		  
		}
		
		/**
		 *  Επιστρέφει τα στοιχεία του χρήστη που έκανε το login εφόσον βρεθεί
		 *
		 */
		public Cursor retrieveUserLogin(String username,String password)
		{
			try 
			{
				String sql=new String();
				sql="SELECT * FROM user where username='"+username+"' and password='"+password+"'";
				Cursor cursor=db.rawQuery(sql,null);
				return cursor;
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
				   return null;
			}
			
			
			
		}
		
		/**
		 *  Προσθέτει ή αφαιρεί ποσότητα προιόντος στο ψυγείο
		 *
		 */
		public void removeOrAddProductAmount(String caseOfChange,String barcode,String quant)
	    {
			try 
			{
				String sql=new String();
				sql="SELECT barcode,user_id,stock from fridge where barcode='"+barcode+"' and user_id='"+SupermarketsAndPricesStaticClass.getUserID()+"'";
				Cursor cursor=db.rawQuery(sql,null);
				if(cursor.getCount()==0)
				{
					Toast.makeText(context,R.string.no_define_in_fridge,Toast.LENGTH_SHORT).show();
				}
				else
				{
					Log.v("TAG removeOrAddProductAmount",quant);
					cursor.moveToNext();
					String theStockString=cursor.getString(cursor.getColumnIndex("stock"));
					int theStock=Integer.parseInt(theStockString);
					if(caseOfChange.equals("add"))
					{
						int newStock=theStock+Integer.parseInt(quant);
						ContentValues cv = new ContentValues();
						cv.put("stock", newStock);
						db.update("fridge", cv, "barcode" + "=" + barcode+" and user_id="+SupermarketsAndPricesStaticClass.getUserID(), null);
					}
					else if(caseOfChange.equals("remove"))
					{
						int newStock=theStock-Integer.parseInt(quant);
						if(newStock>0)
						{
							ContentValues cv = new ContentValues();
							cv.put("stock", newStock);
							db.update("fridge", cv, "barcode" + "=" + barcode+" and user_id="+SupermarketsAndPricesStaticClass.getUserID(), null);
						}
						else
						{
							ContentValues cv = new ContentValues();
							cv.put("stock", "0");
							db.update("fridge", cv, "barcode" + "=" + barcode+" and user_id="+SupermarketsAndPricesStaticClass.getUserID(), null);
						
						}
					}
					
					
				}
				cursor.close();
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}
	    }
		
		/**
		 *  Επιστρέφει όλες τις  λίστες αγορών της βάσης 
		 *
		 */
		public Cursor retrieveUserShoppingLists(String userID,String section)
		{
			try 
			{
				String sql=new String();
				if(section.equals("Lists"))
					sql="SELECT * FROM shopping_list where user_id='"+userID+"' and list_id!='1'";
				else
					sql="SELECT * FROM shopping_list where user_id='"+userID+"'";
				Cursor cursor=db.rawQuery(sql,null);
				Log.v("TAG retrieveUserShoppingLists",Integer.toString(cursor.getCount()));
				return cursor;
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
				   return null;
			}
			
		}
		
		/**
		 *  Επιστρέφει τη λίστα του ηλεκτρονικού ψυγείου
		 *
		 */
		public Cursor retrieveUserFridgeShoppingList(String userID)
		{
			
			try 
			{
				String sql=new String();
				sql="SELECT fridge.barcode,pname,max,min,number_of_purchase,stock FROM fridge,products where user_id='"+userID+"' AND fridge.barcode=products.barcode";
				Cursor cursor=db.rawQuery(sql,null);
				return cursor;
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
				   return null;
			}
			
		}
		
		/**
		 * Διαγράφει μια λίστα αγορών
		 * 
		 * @return
		 */
		public void deleteProductFromFridge(String theBarcode)
		{
			try 
			{
				db.delete("fridge", "barcode=? and user_id=?",new String[] {theBarcode,SupermarketsAndPricesStaticClass.getUserID()});
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}
			
		}
		
		/**
		 *  Επιστρέφει τα προιόντα του ηλεκτρονικού ψυγείου τα οποία βρίσκονται σε έλειψη 
		 *
		 */
		public Cursor retrieveNoStockProductsInFridge(String listID)
		{
			try 
			{
				String sql=new String();
				sql="SELECT pname,fridge.barcode,number_of_purchase FROM fridge,products where fridge.barcode=products.barcode and stock<min";
				Cursor cursor=db.rawQuery(sql,null);
			
				Log.v("TAG retrieveNoStockProductsInFridge",Integer.toString(cursor.getCount()));
				return cursor;
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
				   return null;
			}
			
		}
		
		/**
		 *  Επιστρέφει όλα τα προιόντα μιας συγκεκριμένης λίστας
		 *
		 */
		public Cursor retrieveProductsOfShoppingList(String listID)
		{
			try 
			{
				if(listID.equals("1"))
				{
					String sql=new String();
					sql="SELECT pname,fridge.barcode,min,max,stock,number_of_purchase FROM fridge,products where fridge.barcode=products.barcode";
					
					Cursor cursor=db.rawQuery(sql,null);
					
					return cursor;
				}
				else
				{
					String sql=new String();
					sql="SELECT pname,product_list.barcode,product_amount FROM product_list,products where list_id='"+listID+"' and product_list.barcode=products.barcode";
					
					//sql="SELECT barcode FROM product_list where list_id='"+listID+"'";
					Log.v("TAG","sql -> "+sql);
					Cursor cursor=db.rawQuery(sql,null);
					return cursor;
				}
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
				   return null;
			}
		}
		
		
		/**
		 *  Δημιουργεί μια νέα λίστα αγορών 
		 *
		 */
		public void createUserShoppingList(String userID,String listName,String theDate)
		{
			try 
			{
				ContentValues cv = new ContentValues(3);
				cv.put("user_id",Integer.parseInt(userID));
				cv.put("list_name",listName);
				cv.put("list_date", theDate);
		    	db.insertOrThrow("shopping_list", null, cv);
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}
			
		}
		
		
		/**
		 * Προσθέτει προιόντα σε λίστα. 
		 * @return
		 */
		public void addProductsToUserList(int listID,ArrayList <String>barcodesList,ArrayList <String>barcodesQuantityList)
		{
			for(int i=0;i<barcodesList.size();i++)
			{
				try 
				{
					ContentValues cv = new ContentValues(3);
					cv.put("list_id",listID);
					cv.put("barcode",barcodesList.get(i));
					cv.put("product_amount", barcodesQuantityList.get(i));
				    db.insertOrThrow("product_list", null, cv);
				}
				catch (SQLException e) 
				{
					   Log.e("products", e.toString());
				}
				
			}
			
			
		}
		
		/**
		 * Προσθέτει ένα προιόν σε λίστα. 
		 * @return
		 */
		public void addOneProductToUserList(int listID,String barcode,String productAmount)
		{
			try 
			{
				ContentValues cv = new ContentValues(3);
				cv.put("list_id",listID);
				cv.put("barcode",barcode);
				cv.put("product_amount", productAmount);
			    db.insertOrThrow("product_list", null, cv);
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}	
		}
		
		public Cursor returnTheLastId(String tableName,String columnName)
		{
	    	try 
			{
	    		String sql=new String();
				sql="SELECT "+columnName+" from "+tableName+" order by "+columnName+" DESC limit 1";
				Cursor cursor=db.rawQuery(sql,null);
				
		    	return cursor;
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
				   return null;
			}	
		}
		
		/**
		 * Προσθέτει ένα νέο χρήστη στη βάση δεδομένων
		 * @return
		 */
		public void insertNewUser(String userId,String username,String password,String email,String birthday,String address,String sex)
	    {
			try 
			{
				ContentValues cv = new ContentValues(7);
				if(userId!="null")
				{
					cv.put("user_id",Integer.parseInt(userId));
					cv.put("username",username);
					cv.put("password", password);
			    	cv.put("email", email);
			    	cv.put("birthday",birthday);
			    	cv.put("sex",sex);
			    	cv.put("address",address);
			    	db.insertOrThrow("user", null, cv);
				}
				else 
					return;
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}		
	    }
		
		/**
		 * Επιστρέφει τη ποσότητα ενος προιόντος στο ψυγείο
		 * @return
		 */
		public Cursor quantitiesOfProductInFridge(String barcode)
	    {
			try 
			{
				String sql=new String();
				sql="SELECT max,min,number_of_purchase,stock from fridge where barcode='"+barcode+"' and user_id='"+SupermarketsAndPricesStaticClass.getUserID()+"'";
				Cursor cursor=db.rawQuery(sql,null);
				return cursor;
				
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
				   return null;
			}
	    }
		
		/**
		 * Προσθέτει ένα νέο προιόν στο ψυγείο
		 * @return
		 */
		public void insertNewProductToFridge(String barcode,String maxQ,String minQ,String numP,String currentSt)
	    {
			try 
			{
				String sql=new String();
				sql="SELECT barcode,user_id from fridge where barcode='"+barcode+"' and user_id='"+SupermarketsAndPricesStaticClass.getUserID()+"'";
				Cursor cursor=db.rawQuery(sql,null);
				if(cursor.getCount()==0)
				{
					
						ContentValues cv = new ContentValues(6);
						 cv.put("user_id",SupermarketsAndPricesStaticClass.getUserID());
							cv.put("barcode",barcode);
							cv.put("max", maxQ);
					    	cv.put("min", minQ);
					    	cv.put("number_of_purchase",numP);
					    	cv.put("stock",currentSt);
					    	db.insertOrThrow("fridge", null, cv);
					
				}
				else
				{
					ContentValues cv = new ContentValues();
					cv.put("max", maxQ);
			    	cv.put("min", minQ);
			    	cv.put("number_of_purchase",numP);
			    	cv.put("stock",currentSt);
					db.update("fridge", cv, "barcode" + "=" + barcode+" and user_id="+SupermarketsAndPricesStaticClass.getUserID(), null);
				}
				cursor.close();
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}
	    }
		
		public void insertToBasket(String barcodeNumber)
	    {
			try 
			{
				ContentValues cv = new ContentValues(1);
				cv.put("barcode",barcodeNumber);
				db.insertOrThrow("basket", null, cv);
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}
	    }
		
		/**
		 * Αποθηκεύει ένα νέο προιόν
		 * @return
		 */
		public void storeProductsLocally(String productName,String barcodeNumber,String productIsPacked,String amount,String productItems,String units,String brand,String isSendToServer)
	    {
			try 
			{
				ContentValues cv = new ContentValues(10);
				cv.put("pname",productName);
				cv.put("barcode", barcodeNumber);
		    	cv.put("amount",amount);
		    	cv.put("units",units);
		    	cv.put("is_packed",productIsPacked);
		    	cv.put("brand",brand);
		    	cv.put("is_packed_items",productItems);
		    	cv.put("is_stored_to_server",isSendToServer);
		    	db.insertOrThrow("products", null, cv);
			}
			catch (SQLException e) 
			{
				   Log.e("products", e.toString());
			}	
	    }
		
		/**
		 * Αποθηκεύει τα προιόντα που σαρώνονται και δε μπορούν να σταλθούν στον server
		 * @return
		 */
		public Cursor retrieveAllNoStoredProductsLocally()
		{
			
			
			try 
			{
				String sql=new String();
				sql="SELECT * FROM products where is_stored_to_server='false'";
				Cursor cursor=db.rawQuery(sql,null);
				return cursor;
			}
			catch (SQLException e) 
			{
				Log.e("products", e.toString());
				return null;
			}
		}
		
		/**
		 * Επιστρέφει τα στοιχεία προιόντος με συγκεκριμένο barcode
		 * 
		 * @return
		 */
		public Cursor retrieveSpecificProduct(String theBarcode)
		{
			try 
			{
				String sql=new String();
				sql="SELECT * FROM products where barcode='"+theBarcode+"'";
				Cursor cursor=db.rawQuery(sql,null);
				return cursor;
			}
			catch (SQLException e) 
			{
				Log.e("products", e.toString());
				return null;
			}
		}
		
		/**
		 * Διαγράφει μια λίστα
		 * 
		 * @return
		 */
		public void deleteProductList(String theList)
		{
			
			try 
			{
				db.delete("shopping_list", "list_id=?",new String[] {theList});
				db.delete("product_list", "list_id=?",new String[] {theList});
			}
			catch (SQLException e) 
			{
				Log.e("products", e.toString());
			}
		}
		
		/**
		 * Διαγράφει προιόντα απο λίστα
		 * 
		 * @return
		 */
		public void deleteProductFromList(String theList,String theBarcode)
		{
			
			try 
			{
				db.delete("product_list", "list_id=? and barcode=?",new String[] {theList,theBarcode});
			}
			catch (SQLException e) 
			{
				Log.e("products", e.toString());
			}
		}
		
		
		public void changeStateOfNoSentProducts(String barcode)
	    {
			 
			 try 
			{
				 ContentValues cv = new ContentValues();
				 cv.put("is_stored_to_server", "true");
				 db.update("products", cv, "barcode" + "=" + barcode, null);
				//db.delete("no_store_products", "barcode=?",new String[] {barcode});
			}
			catch (SQLException e) 
			{
				Log.e("products", e.toString());
			}
			 
	    }
		
		public void closeDB()
	    {
			myDb.close();
			db.close();
	    }	
		
		/**
		 * Δημιουργεί τη λίστα του ψυγείου
		 * 
		 * @return
		 */
		public void createFridgeListIfNotExists()
		{
			try 
			{
				String sql=new String();
				sql="SELECT list_id,user_id,list_name from shopping_list where list_id='1'";
				Cursor cursor=db.rawQuery(sql,null);
				//cursor.moveToNext();
				//Log.v("TAG retrieveNoStockProductsInFridge",Integer.toString(cursor.getCount()));
				//Log.v("TAG list_id",Integer.toString(cursor.getInt(cursor.getColumnIndex("list_id"))));
				//Log.v("TAG user_id",Integer.toString(cursor.getInt(cursor.getColumnIndex("user_id"))));
				//Log.v("TAG list_name",cursor.getString(cursor.getColumnIndex("list_name")));
				if(cursor.getCount()==0)
				{
					ContentValues cv=new ContentValues();
					cv.put("list_id", "1");
					cv.put("user_id", SupermarketsAndPricesStaticClass.getUserID());
					cv.put("list_name", res.getString(R.string.fridge_name));
					cv.put("list_date", "");
					db.insertOrThrow("shopping_list", null, cv);
				}
				cursor.close();
			}
			catch (SQLException e) 
			{
				Log.e("products", e.toString());
			}	
		}	
			
		
		
}		
		
