package org.supermarket.gr;

import java.util.ArrayList;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
/**
 * Σχεδιάζει το GUI στο οποίο παρουσιάζονται οι αποθηκευμένες λίστες του χρήστη και η
 *  λίστα του ηλεκτρονικού ψυγείου με σκοπό την αναζήτηση προσφοράς για κάποια από αυτές
 */
public class FindBestOfferForList extends Activity implements OnClickListener
{
	protected ListView  topList;
	//protected EnterpriseDatabase ed;
	public static final String USER_STORED = "User_stored";
	protected Cursor cursor;
	protected String theUserID;
	protected Resources res;
	protected TextView noItemsText;
	protected ArrayList<String> theIdOfLists;
	protected Context thisContext;
	
	 @Override
	    public void onCreate(Bundle savedInstanceState) 
	    {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.find_best_offer_for_list);
	        
	        SharedPreferences current_session = getSharedPreferences(USER_STORED, 0);
	        theUserID=new String();
	    	theUserID = current_session.getString("user_id", "nill");
	    	//ed=new EnterpriseDatabase(this);
	        topList=(ListView)findViewById(R.id.lv);
	        res = getResources();
	        
	        theIdOfLists= new ArrayList<String>( );
	        thisContext=this.getApplicationContext();
	        loadShoppingLists();
	        if(topList.getCount()==0)
	        {
	        	noItemsText=(TextView)findViewById(R.id.info_text_offers);
	        	noItemsText.setText(res.getString(R.string.no_list_offer));
	        	
	        }
	 	}
	 
	    @Override
		public void onBackPressed() 
	    {
			this.finish();
		}
	    
	    /**
	     * Φορτώνει σε μνια λίστα όλες τις διαθέσιμες λίστες αγορών
	     * */
	    public void loadShoppingLists()
	    {
	    	DatabaseCommunication ed=new DatabaseCommunication(this);
	    	cursor=ed.retrieveUserShoppingLists(theUserID,"Map");
	    	int rowCounts=cursor.getCount();
	    	Log.v("TAG rowCounts : ",Integer.toString(rowCounts));
	    	Log.v("TAG theUserID : ",theUserID);
	    	String shoppingLists[]=new String[rowCounts];
	    	if(rowCounts>0)
	    	{
	    		int counter=0;
	    		while(cursor.moveToNext())
	   		 	{
	    			Log.v("TAG rowCounts","mpike");
	    			shoppingLists[counter]=new String(cursor.getString(cursor.getColumnIndexOrThrow("list_name")));
	    			theIdOfLists.add(new String(cursor.getString(cursor.getColumnIndexOrThrow("list_id"))));
	    			
	    			counter++;
	   		 	}
	    		
	    		//txtv.setText(DateTop20);
	        	topList.setAdapter(new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1,shoppingLists));
	        	topList.setFocusable(true);
	        	topList.setOnItemClickListener(new OnItemClickListener() 
	         	{
	        		public void onItemClick(AdapterView<?> a, View v, int position, long id)
	        		{
	        			Intent bestOffersActivity=new Intent(thisContext,SuperMarketInMap.class);
	        			bestOffersActivity.putExtra("selected_list_id",theIdOfLists.get(position));
	    				startActivity(bestOffersActivity);
	        				
	        				
	        		}
	        	});
	    	}
			cursor.close();
			ed.closeDB();
	    }
	    
	    public void onClick(View v)
	    {
	    	switch(v.getId())
	    	{
	    		case R.id.add_shopping_list_id:
	    			Intent newList = new Intent(getApplicationContext(),NewShoppingList.class);
	    			startActivity(newList);
	    			
					break;
	    	}
	    }
}
