package org.supermarket.gr;


import android.content.ContentValues;
import android.content.Context;
import android.content.res.Resources;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

public class HelpDatabase extends SQLiteOpenHelper 
{
	private static final String DATABASE_NAME="supermarket";
	private static final int CONFLICT_ABORT = 2;
	protected Resources res;
	
	public HelpDatabase(Context context) 
	{
		//H teleutaia parametros sth super afora thn ekdosh. 
		//An allaksw thn timh ths tote oi entoles sthn onCreate kai sthn onUpgrade tha ektelestoun . Alliws h vash paramenei idia
		super(context, DATABASE_NAME, null, 8);  
		res = context.getResources();
	}
	
	
	@Override
	public void onCreate(SQLiteDatabase db) 
	{
		//We store at this table the products we are scanning.
		db.execSQL("CREATE TABLE products(product_id INTEGER PRIMARY KEY,pname TEXT,barcode TEXT, is_packed TEXT, amount TEXT,is_packed_items TEXT, units TEXT,brand TEXT,is_stored_to_server TEXT)");
		
		//We store at this table the users who use the app
		db.execSQL("CREATE TABLE user(user_id INTEGER PRIMARY KEY,username TEXT NOT NULL,password TEXT NOT NULL,email TEXT NOT NULL, address TEXT, birthday TEXT, sex TEXT)");
		
		//We store at this table all the shopping lists of all the users who use the app
		db.execSQL("CREATE TABLE shopping_list(list_id INTEGER PRIMARY KEY AUTOINCREMENT,user_id INTEGER, list_name TEXT, list_date TEXT)");
		
		db.execSQL("CREATE TABLE product_list(list_id INTEGER, barcode TEXT,product_amount TEXT ,PRIMARY KEY (list_id, barcode))");
		
		db.execSQL("CREATE TABLE fridge(barcode TEXT, user_id INTEGER, stock TEXT, min TEXT, max TEXT, number_of_purchase TEXT, PRIMARY KEY (barcode,user_id))");
		
		db.execSQL("CREATE TABLE basket(barcode TEXT, PRIMARY KEY (barcode))");
		
		//insertListFridge(db);
	
	}
	
	 /**
     * Δημιουργεί τη λίστα του ψυγείου
     * */
	public void insertListFridge(SQLiteDatabase db) 
	{
		try 
		{
			String sql=new String();
			sql="SELECT list_id from shopping_list where list_id='1'";
			Cursor cursor=db.rawQuery(sql,null);
			if(cursor.getCount()==0)
			{
				ContentValues cv=new ContentValues();
				cv.put("list_id", "1");
				cv.put("user_id", SupermarketsAndPricesStaticClass.getUserID());
				cv.put("list_name", res.getString(R.string.fridge_name));
				cv.put("list_date", "");
				db.insertOrThrow("shopping_list", null, cv);
			}
		}
		catch (SQLException e) 
		{
			Log.e("products", e.toString());
		}
		
	}
	
	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) 
	{
		db.execSQL("DROP TABLE IF EXISTS user");
		db.execSQL("DROP TABLE IF EXISTS fridge");
		//db.execSQL("DROP TABLE IF EXISTS no_store_products");
		db.execSQL("DROP TABLE IF EXISTS basket");
		db.execSQL("DROP TABLE IF EXISTS shopping_list");
		db.execSQL("DROP TABLE IF EXISTS product_list");
		db.execSQL("DROP TABLE IF EXISTS products");
		
		onCreate(db);
	}
	
}

