package org.supermarket.gr;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.widget.Toast;

/**
 *  Η κλάση αυτή είναι υπεύθυνη για επικοινωνία με τη βάση δεδομένων του server. Σκοπός της επικοινωνίας είναι
 *  η εύρεση του χρήστη που έκανε το login
 *
 */
public class LoginUserCommunicate extends AsyncTask<String, Void, Integer> 
{
	/**
     * Το περιεχόμενο του Activity LoginUserUI.
    */
	private Activity activityContext;
	/**
     * Boolean μεταβλητή για την ύπαρξη σύνδεσης Internet
    */
	protected boolean online;
	/**
     * Το url που αντιστοιχεί στο web service για την εύρεση χρήστη στη κεντρική βάση δεδομένων
    */
	protected String findUserUrl;
	/**
     * Πίνακας με τα πλήρη στοιχεία του χρήστη που βρέθηκε
    */
	private String details[];
	protected ProgressDialog dialogDB;
	/**
     * Το username που όρισε ο χρήστης
    */
	protected String usersUsername;
	/**
     * Το password που όρισε ο χρήστης
    */
	protected String usersPassword;
	/**
     * Κλειδί αποθηκευμένο στα SharedPreferences που αφορά την το ID του χρήστη που είναι συνδεδεμένος στην εφαρμογή
    */
	public static final String USER_STORED = "User_stored";
	
	public LoginUserCommunicate(Activity context,String theUsername,String thePassword) 
	{
		activityContext = context;
		usersUsername=new String(theUsername);
		usersPassword=new String(thePassword);
	}
	
	@Override
	 protected void onPreExecute()
	 {
		//findUser="http://supermarket.flexmarket.biz/json/find_user.php?username="+username.getText().toString()+"&password="+password.getText().toString();
		findUserUrl="http://supermarket.flexmarket.biz/json/find_user.php";
		
		dialogDB = new ProgressDialog(activityContext);
		dialogDB = ProgressDialog.show(activityContext,activityContext.getResources().getText(R.string.wait_please),activityContext.getResources().getText(R.string.test_database), true);
		
		online=isOnline();
	 }
	
	
	/**
     * Συναρτηση για τον έλεγχο συνδεσιμότητας με το Internet.
    */
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) activityContext.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}
	
   
	@Override
	protected Integer doInBackground(String... urls)
	{
		if(online==true)
  	  	{
    	    try 
			{
    	    	HttpClient client= new DefaultHttpClient();
    	    	StringBuilder url=new StringBuilder(findUserUrl);
				//get=new HttpGet(url.toString());
				HttpPost post=new HttpPost(url.toString());
				
				List<NameValuePair> value=new ArrayList<NameValuePair>();
		        value.add(new BasicNameValuePair("username",usersUsername));
		        value.add(new BasicNameValuePair("password",usersPassword));
		       
		        
		        UrlEncodedFormEntity entity=new UrlEncodedFormEntity(value);
		        post.setEntity(entity);
		        HttpResponse r = client.execute(post);
		        int status=r.getStatusLine().getStatusCode();
				if(status==200)
				{
					HttpEntity e=r.getEntity();
					String data =EntityUtils.toString(e);
					
					JSONArray	jsonData = new JSONArray("["+data+"]");
					JSONObject jsonObjects = null;
					jsonObjects =jsonData.getJSONObject(0);
					int countRows=Integer.parseInt(jsonObjects.getString("total_rows"));
					
					if(countRows==0)
					{
						return 2;
					}
					else
					{
						details=new String[7];
						JSONArray content =jsonObjects.getJSONArray("content");
						
						JSONObject last3=null;
						last3=(JSONObject) content.get(0);
							
							if(last3.isNull("username"))
								details[0]="null";
							else
								details[0]=last3.getString("username");
							
							if(last3.isNull("password"))
								details[1]="null";
							else
								details[1]=last3.getString("password");
							
							if(last3.isNull("email"))
								details[2]="null";
							else
								details[2]=last3.getString("email");
						
							if(last3.isNull("birthday"))
								details[3]="null";
							else
								details[3]=last3.getString("birthday");
							
							if(last3.isNull("address"))
								details[4]="null";
							else
								details[4]=last3.getString("address");
							
							if(last3.isNull("sex"))
								details[5]="null";
							else
								details[5]=last3.getString("sex");
							
							if(last3.isNull("id"))
								details[6]="null";
							else
								details[6]=last3.getString("id");
							
							return 1;
							
					}
				}
				else 
					return 3;
			} 
			catch (ClientProtocolException e1) 
			{
				return 3;
			} 
			catch (IOException e1) 
			{
				return 3;
			} 
    	    catch (JSONException e) 
    	    {
				// TODO Auto-generated catch block
    	    	return 3;
			} 
			
  	  	}
		else 
			return 0;
			
	}
	
	@Override
    protected void onCancelled() 
	{
		dialogDB.dismiss();
    }

	@Override
    protected void onPostExecute(Integer result)
    {
    	if(result==1)
		{
    		DatabaseCommunication ed=new DatabaseCommunication(activityContext);
			ed.insertNewUser(details[6],details[0],details[1],details[2],details[3],details[4],details[5]);
			
    		//cursor=ed.retrieveUserLogin(details[0], details[1]);
			SharedPreferences user = activityContext.getSharedPreferences(USER_STORED, 0);
 		    SharedPreferences.Editor editor = user.edit();
 			editor.putString("username", details[0]);
 			editor.putString("password",details[1]);
 			editor.putString("user_id",details[6]);
 			editor.commit();
 			SupermarketsAndPricesStaticClass.setUserID(details[6]);
 			
 			ed.closeDB();
 			
 			Intent firstActivity = new Intent(activityContext,MainActivityUI.class);
 			activityContext.startActivity(firstActivity);
 			activityContext.finish();
		}
    	else if(result==0)
    	{
    		Toast.makeText(activityContext,R.string.no_internet,Toast.LENGTH_LONG).show();
    	}
    	else if(result==2)
    	{
    		Toast.makeText(activityContext,R.string.no_find_user,Toast.LENGTH_LONG).show();
    	}
    	else if(result==3)
    	{
    		Toast.makeText(activityContext,R.string.network_error,Toast.LENGTH_LONG).show();
    		Toast.makeText(activityContext,R.string.network_error_sol,Toast.LENGTH_LONG).show();
    		
    	}
    	dialogDB.dismiss();
    }

}