package org.supermarket.gr;

import java.io.IOException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;

public class LoginUserSendLocalData extends AsyncTask<String, Void,Boolean> 
{
	/**
     * Το περιεχόμενο του Activity LoginUserUI.
    */
	private Activity activityContext;
	/**
     * Boolean μεταβλητή για την ύπαρξη σύνδεσης Internet
    */
	protected boolean online;
	/**
     * Το url που αντιστοιχεί στο web service για την εύρεση χρήστη στη κεντρική βάση δεδομένων
    */
	protected String webServiceUrl="http://supermarket.flexmarket.biz/database/insert_barcode.php";
	/**
     * Αντικείμενο τύπου DatabaseCommunication για την διασύνδεση με τη τοπική βάση δεδομένων και την αποστολή επερωτήσεων
    */
	protected DatabaseCommunication ed;
	protected ProgressDialog dialogDB;
	/**
 	 *  Πίνακας που περιέχει δεδομένα της τοπικής βάσης δεδομένων που δεν έχουν σταλθεί στη κεντρική βάση δεδομένων. 
 	 *
 	 */
	protected String[][] incompleteRequests;
	
	public LoginUserSendLocalData(Activity context,String[][] req) 
	{
		activityContext = context;
		incompleteRequests=req;
	}
	
	@Override
	 protected void onPreExecute()
	 {
		dialogDB = new ProgressDialog(activityContext);
		dialogDB = ProgressDialog.show(activityContext,activityContext.getResources().getText(R.string.wait_please),activityContext.getResources().getText(R.string.test_database), true);
		
		online=isOnline();
		
 	    ed=new DatabaseCommunication(activityContext);
	 }
	
	/**
     * Συναρτηση για τον έλεγχο συνδεσιμότητας με το Internet.
    */
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) activityContext.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}
	
	@Override
	protected Boolean doInBackground(String... urls)
	{
		if(online==true)
  	  	{
			for(int i=0;i<incompleteRequests.length;i++)
			{
				System.out.println("incompleteRequests : "+ incompleteRequests[i][0]);
				
				 try 
				{
					  	String barcodeUrl=new String();
	        	    	barcodeUrl=webServiceUrl+"?pname="+incompleteRequests[i][0]+"&barcode="+incompleteRequests[i][1]+"&sname="+incompleteRequests[i][2]+"&amount="+incompleteRequests[i][3]+"&units="+incompleteRequests[i][4]+"&isoffer="+incompleteRequests[i][5]+"&ispack="+incompleteRequests[i][6]+"&items="+incompleteRequests[i][7]+"&product_value="+incompleteRequests[i][8];
	        	    	
	        	    	barcodeUrl.replaceAll("\\s+", " ");
	        	    	barcodeUrl=barcodeUrl.replace(' ', '+');
	        	    	
	        	    	HttpClient client= new DefaultHttpClient();
	        	    	StringBuilder url=new StringBuilder(barcodeUrl);
						HttpGet get=new HttpGet(url.toString());
						
						HttpResponse r = client.execute(get);
						
						int status=r.getStatusLine().getStatusCode();
						if(status==200)
						{
							//delete the request from database because I send product to server successfully
							
							
							ed.changeStateOfNoSentProducts(incompleteRequests[i][1]);
							
							continue;
						}
						else 
							continue;
						
					} 
					catch (ClientProtocolException e1) 
					{
						
						e1.printStackTrace();
						continue;
					} 
					catch (IOException e1) 
					{
						
						e1.printStackTrace();
						continue;
					}
			}
			return true;
			
  	  	}
		else 
			return false;
			
	}
	
	@Override
    protected void onCancelled() 
	{
		dialogDB.dismiss();
    }

	@Override
    protected void onPostExecute(Boolean result)
    {
		ed.closeDB();
    	dialogDB.dismiss();
    	
    	Intent firstActivity = new Intent(activityContext,MainActivityUI.class);
    	activityContext.startActivity(firstActivity);
    	activityContext.finish();
    }

}