package org.supermarket.gr;


import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;

public class MainActivityUI extends Activity implements OnClickListener
{
	protected View scanning;
	protected View manageList;
	protected View bestPrice;
	protected View myFridge;
	/**
     * Κλειδί αποθηκευμένο στα SharedPreferences που αφορά την το ID του χρήστη που είναι συνδεδεμένος στην εφαρμογή
    */
	public static final String USER_STORED = "User_stored";
	private final int SETTINGS_ACTIVITY_REQUEST_CODE=1;
	/**
     * Κλειδί αποθηκευμένο στα SharedPreferences που αφορά τη περίπτωση ενεργειών ανανέωσης
    */
	public static final String PREFS_NAME = "Update_settings";
	
    
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        DatabaseCommunication ed=new DatabaseCommunication(this);
    	ed.createFridgeListIfNotExists();
    	ed.closeDB();
        
        //titleBar = (TextView) findViewById(R.id.title_bar);
        bestPrice  = (ImageView) findViewById(R.id.best_price_bt);
        bestPrice.setOnClickListener(this);
        
        manageList  = (ImageView) findViewById(R.id.manage_list);
        manageList.setOnClickListener(this);
        
        myFridge=(ImageView)findViewById(R.id.my_fridge_bt);
        myFridge.setOnClickListener(this);
        
        scanning=(ImageView)findViewById(R.id.scan_bt);
        scanning.setOnClickListener(this);  
         
       	
    }
    
    public void onClick(View v)
    {
    	switch(v.getId())
    	{
    		case R.id.best_price_bt:
				Intent findBestOffersActivity=new Intent(this,FindBestOfferForList.class);
				startActivity(findBestOffersActivity);
				break;
    		case R.id.manage_list:
    			Intent userLists=new Intent(this,UserProductLists.class);
    			startActivity(userLists);
    			break;
    		case R.id.my_fridge_bt:
    			Intent intentManageFridge=new Intent(this,ManageFridgeUI.class);
    			startActivity(intentManageFridge);
    			break;
    		case R.id.scan_bt:
    			Intent scanner=new Intent(this,ChangeProductsFridgeQuantity.class);
    			startActivity(scanner);
    			break;
    		
    	}
    }
    
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        super.onCreateOptionsMenu(menu);
        addRegularMenuItems(menu);
        return true;
    }
    
    /**
     * Το περιεχόμενο του menu
    */
    private void addRegularMenuItems(Menu menu)
    {
        int base=Menu.FIRST; 
        menu.add(base,1,base,R.string.logout);
        menu.add(base,2,base,R.string.info);
        menu.add(base,3,base,R.string.settings);
        
        
        menu.findItem(1).setIcon(R.drawable.logout);
        menu.findItem(2).setIcon(R.drawable.info);
        menu.findItem(3).setIcon(R.drawable.settings);
     
         
    }
    
    /**
     * Ορίζονται οι ενέργειες των επιλογών στο menu
    */
    public boolean onOptionsItemSelected(MenuItem item) 
    {
        if (item.getItemId() == 1) 
        {
        	SharedPreferences user = getSharedPreferences(USER_STORED, 0);
 		    SharedPreferences.Editor editor = user.edit();
 			editor.remove("username");
 			editor.remove("password");
 			editor.remove("user_id");
 			editor.commit();
 			Intent loginUser = new Intent(getApplicationContext(), LoginUserUI.class);
            startActivity(loginUser);
            finish();
        	
        }
        else if (item.getItemId() == 2) 
        {
        	Intent info=new Intent(getApplicationContext(), Info.class);
        	startActivity(info);
			
        }
        else if (item.getItemId() == 3) 
        {
        	Intent settings=new Intent(getApplicationContext(), Settings.class);
        	startActivityForResult(settings, SETTINGS_ACTIVITY_REQUEST_CODE);
			
        }
      
      
        return true;
   }
    
    
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent intent)
    {
        super.onActivityResult(requestCode, resultCode, intent);
        Bundle extras = intent.getExtras();
        if(extras != null)
        {
        	switch (requestCode) 
	        {
    	        case SETTINGS_ACTIVITY_REQUEST_CODE:
    	        	if(!extras.getString("returnKey").equals("nill"))
    	        	{
    	        		SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
    	        	    SharedPreferences.Editor editor = settings.edit();
    	        	    editor.putString("update", extras.getString("returnKey"));
    	        	    editor.commit();
    	        	}
    	        	
    	        	break;
	        }
        	
        }	
    }
}