package org.supermarket.gr;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.ContentValues;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

/**
 * Παρέχει μεθόδους για την αλλαγή των ποσοτήτων του κάθε προϊόντος μέσα στο ηλεκτρονικό ψυγείο 
 **/
public class ManageFridgeDatabaseStore extends Activity implements OnClickListener
{
	protected EditText maxQuantity;
	protected EditText minQuantity;
	protected EditText quantityOfPurchase;
	protected EditText currentStock;
	protected Button storeQuantities;
	protected String bardoceScanned;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.fridge_quantities);
		
		Bundle extras = getIntent().getExtras();
		if(extras !=null) 
			bardoceScanned=new String(extras.getString("barcodescanned"));
		 Log.v("TAG","bardoceScanned "+bardoceScanned);
		setActions();
	}
	
	
	void setActions()
	{
		maxQuantity=(EditText) findViewById(R.id.max_quantity);
        minQuantity=(EditText) findViewById(R.id.min_quantity);
        quantityOfPurchase=(EditText) findViewById(R.id.number_of_purchase);
        currentStock=(EditText) findViewById(R.id.current_stock_id);
        
        storeQuantities=(Button) findViewById(R.id.fridge_settings_store);
        storeQuantities.setOnClickListener(this);
        
        DatabaseCommunication ed=new DatabaseCommunication(this.getApplicationContext());
		Cursor cursor=ed.quantitiesOfProductInFridge(bardoceScanned);
		cursor.moveToNext();
		if(cursor!=null)
		{
			if(cursor.getCount()>0)
			{
				
				maxQuantity.setText( cursor.getString(cursor.getColumnIndex("max")) );
				minQuantity.setText( cursor.getString(cursor.getColumnIndex("min")) );
				quantityOfPurchase.setText( cursor.getString(cursor.getColumnIndex("number_of_purchase")) );
				currentStock.setText( cursor.getString(cursor.getColumnIndex("stock")) );
				
			}
		}
	}
	
	
	public void onClick(View v) 
	{
		 switch(v.getId())
	      {
			     case R.id.fridge_settings_store:
			    	/* int differenceMaxMin=Integer.parseInt(maxQuantity.getText().toString())-Integer.parseInt(minQuantity.getText().toString());
			    	 int purchaseValue=Integer.parseInt(quantityOfPurchase.getText().toString());
			    	 if(differenceMaxMin< purchaseValue)
			    	 {
			    		 DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() 
			         	{
			         	    public void onClick(DialogInterface dialog, int which) 
			         	    {
			         	        switch (which)
			         	        {
			         	        case DialogInterface.BUTTON_POSITIVE:
			         	        	storeQunatities();
			         	            break;

			         	        case DialogInterface.BUTTON_NEGATIVE:
			         	            //No button clicked
			         	        	//finish();
			         	            break;
			         	        }
			         	    }
			         	};

			         	AlertDialog.Builder builder = new AlertDialog.Builder(this);
			         	builder.setMessage(res.getString(R.string.more_that_max_value_alert)).setPositiveButton("Yes", dialogClickListener).setNegativeButton("No", dialogClickListener).show();
			         
			    	 }
			    	 else
			    	 {
			    		 EnterpriseDatabase ed=new EnterpriseDatabase(this.getApplicationContext());
			    		 ed.insertNewProductToFridge(bardoceScanned,maxQuantity.getText().toString(),minQuantity.getText().toString(),quantityOfPurchase.getText().toString());
			    		 ed.closeDB();
			    	 }*/
			    	 DatabaseCommunication ed=new DatabaseCommunication(this.getApplicationContext());
		    		 ed.insertNewProductToFridge(bardoceScanned,maxQuantity.getText().toString(),minQuantity.getText().toString(),quantityOfPurchase.getText().toString(),currentStock.getText().toString());
		    		 ed.closeDB();
			    	 break;
			    
	      }
		 Intent intent = new Intent();
		 intent.putExtra("returnKey","nill");
		 setResult(RESULT_OK,intent);
		 finish();
	}
	
	public void storeQunatities()
	{
		DatabaseCommunication ed=new DatabaseCommunication(this.getApplicationContext());
		 ed.insertNewProductToFridge(bardoceScanned,maxQuantity.getText().toString(),minQuantity.getText().toString(),quantityOfPurchase.getText().toString(),currentStock.getText().toString());
		 ed.closeDB();
	}
	
	 public void onBackPressed()
	 {
		 Intent intent = new Intent();
		 intent.putExtra("returnKey","nill");
		 setResult(RESULT_OK,intent);
		finish();
	 }
}
