package org.supermarket.gr;

import java.util.ArrayList;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.database.Cursor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

/**
 *Σχεδιάζει το GUI για την διαχείριση του ηλεκτρονικού ψυγείου. Πιο συγκεκριμένα παρουσιάζονται όλα τα προϊόντα του ψυγείου και δίνεται η δυνατότητα 
 *τροποποίησης των ρυθμίσεων του ψυγείου και προσθήκης νέων προϊόντων μέσω 
 *κατάλληλης διεπαφής. 
 */
public class ManageFridgeUI extends Activity implements OnClickListener
{
	protected ListAdapter listAdapter;
	protected ListView  fridgeList;
	protected TextView noItemsText;
	protected Resources res;
	public static final String USER_STORED = "User_stored";
	protected String theUserID;
	protected ArrayList<String> barcodesOfFridge;
	protected ArrayList<String> barcodesDateOfFridge;
	int barcodesOfTheFridgeIndex;
	protected String upc;
	int theSelectedProductFromFridgeList;
	String fridgeBarcodes[];
	
	private final int SET_QUANTITIES_REQUEST_CODE=120;
	private final int ADD_BARCODE_REQUEST_CODE=121;
	
	@Override
    public void onCreate(Bundle savedInstanceState) 
    {
		super.onCreate(savedInstanceState);
	    setContentView(R.layout.manage_fridge);

	    TextView addToFridgeTxt = (TextView) findViewById(R.id.add_product_to_fridge_id_txt);
	    addToFridgeTxt.setOnClickListener(this);
	    ImageView addToFridge  = (ImageView) findViewById(R.id.add_product_to_fridge_id);
	    addToFridge.setOnClickListener(this);
	    
	    barcodesOfTheFridgeIndex=0;
	    barcodesOfFridge= new ArrayList<String>( );
		barcodesDateOfFridge= new ArrayList<String>( );
		
	    res = getResources();
	    
	    
	    SharedPreferences current_session = getSharedPreferences(USER_STORED, 0);
        theUserID=new String();
    	theUserID = current_session.getString("user_id", "nill");
	    
	    fridgeList=(ListView)findViewById(R.id.lv_fridge);
	    loadShoppingLists();
        if(fridgeList.getCount()==0)
        {
        	noItemsText=(TextView)findViewById(R.id.info_text_fridge);
        	noItemsText.setText(res.getString(R.string.no_fridge_products));
        	
        }
	    
    }
	
	public void loadShoppingLists()
    {
		theSelectedProductFromFridgeList=0;
		fridgeBarcodes=null;
    	DatabaseCommunication ed=new DatabaseCommunication(this);
    	Cursor cursor=ed.retrieveUserFridgeShoppingList(theUserID);
    	int rowCounts=cursor.getCount();
    	String fridgeProducts[]=new String[rowCounts];
    	fridgeBarcodes=new String[rowCounts];
    	if(rowCounts>0)
    	{
    		int counter=0;
    		while(cursor.moveToNext())
   		 	{
    			fridgeProducts[counter]=new String(cursor.getString(cursor.getColumnIndexOrThrow("pname")));
    			fridgeBarcodes[counter]=new String(cursor.getString(cursor.getColumnIndexOrThrow("barcode")));
    			//theIdOfLists.add(new String(cursor.getString(cursor.getColumnIndexOrThrow("list_id"))));
    			//editor.putString("username", cursor.getString(cursor.getColumnIndexOrThrow("username")));
   		 			//editor.putString("password",cursor.getString(cursor.getColumnIndexOrThrow("password")));
   		 			//editor.putString("user_id",cursor.getString(cursor.getColumnIndexOrThrow("user_id")));
   		 			//editor.commit();
    			//System.out.println(cursor.getInt(cursor.getColumnIndexOrThrow("list_id")));
    			counter++;
   		 	}
    		
    		//txtv.setText(DateTop20);
    		listAdapter=null;
    		listAdapter=new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1,fridgeProducts);
    		
    		fridgeList.setAdapter(listAdapter);
    		fridgeList.setFocusable(true);
    		fridgeList.setOnCreateContextMenuListener(this);
    		fridgeList.setOnItemClickListener(new OnItemClickListener() 
         	{
        		public void onItemClick(AdapterView<?> a, View v, int position, long id)
        		{
        			Log.v("TAG Positionnnnnnnnnnnnnn","position -> "+position);
        			theSelectedProductFromFridgeList=position;
        			openTheContextMenu(v);	
        		}
        	});
    	}
    	else
    	{
    		listAdapter=null;
    		listAdapter=new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1,new String[]{res.getString(R.string.no_fridge_products)});
    		fridgeList.setAdapter(listAdapter);
    		fridgeList.setFocusable(true);
    	}
		cursor.close();
		ed.closeDB();
    }
	
	void openTheContextMenu(View v)
	{
		this.openContextMenu(v);
	}
	
	 @Override
	    public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) 
	    {
	        menu.setHeaderTitle("Fridge");
	        menu.add(0, 0, 0, res.getString(R.string.fridge_context_menu_text1));
	        menu.add(0, 1, 0, R.string.fridge_context_menu_text2);
	    }
	    
	    @Override
	    public boolean onContextItemSelected(MenuItem item) 
	    {
	        
	        	if(item.getItemId()==0)
	        	{
	        		Intent quantities = new Intent(getApplicationContext(),ManageFridgeDatabaseStore.class);
		            quantities.putExtra("barcodescanned",fridgeBarcodes[theSelectedProductFromFridgeList]);
			        startActivity(quantities);
	        	}
	        	if(item.getItemId()==1)
	        	{
	        		DatabaseCommunication ed=new DatabaseCommunication(this);
	        		ed.deleteProductFromFridge(fridgeBarcodes[theSelectedProductFromFridgeList]);
	        		ed.closeDB();
	        		loadShoppingLists();
	        	}
	        	
	        	
	            return true;
	    }
	
	public void onClick(View v)
    {
    	switch(v.getId())
    	{
    		case R.id.add_product_to_fridge_id:
    			IntentIntegrator integrator = new IntentIntegrator(this);
    			integrator.initiateScan();
				break;
    		case R.id.add_product_to_fridge_id_txt:
    			IntentIntegrator integrator1 = new IntentIntegrator(this);
    			integrator1.initiateScan();
				break;
    	}
    }
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{
		super.onActivityResult(requestCode, resultCode, intent);
		switch (requestCode) 
        {
	        case SET_QUANTITIES_REQUEST_CODE: 
	        	loadShoppingLists();
	        	break;
	        case ADD_BARCODE_REQUEST_CODE:
	        	if(resultCode == RESULT_OK) 
				{
		        	Intent quantities = new Intent(this,ManageFridgeDatabaseStore.class);
		        	quantities.putExtra("barcodescanned",upc);
				    startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
		        }
		        else
		        	Toast.makeText(this,R.string.edit_barcode_fields_p,Toast.LENGTH_SHORT).show();
		        
	        	break;
	        default:
	        	IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, intent);
		  		  if (scanResult != null) 
		  		  {
		  			  upc = scanResult.getContents();
		  			  			//validBarcode=true;
		  					  if(resultCode == RESULT_OK) 
		  					  {
		  						  BarcodeExistsInDB task = new BarcodeExistsInDB(this,upc,"ManageFridge");
		  						  task.execute(new String[] { "" });
		  						  
		  						  barcodesOfFridge.add(upc);
		  						  barcodesDateOfFridge.add("1");
		  						 // barcodesOfTheList[barcodesOfTheListIndex][0]=upc;
		  						 // barcodesOfTheList[barcodesOfTheListIndex][1]="1";
		  						  barcodesOfTheFridgeIndex++;
		  						  
		  					  }
		  					  else if(resultCode == RESULT_CANCELED)
		  					  {
		  					  }
		  		  }
		  		  break;
        }
		  
	}
	
}
