package org.supermarket.gr;

import java.io.IOException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;


/**
 * Με τη NewBarcodeCommunicate γίνεται η επικοινωνία 
 * με τη κεντρική βάση δεδομένων για την αποστολή των στοιχείων του barcode που σαρώθηκε.
 */
public class NewBarcodeCommunicate extends AsyncTask<String, Void,Boolean> 
{
	private Activity activityContext;
	protected boolean online;
	protected HttpGet get;
	protected HttpResponse r;
	protected int status;
	HttpClient client;
	StringBuilder url;
	protected String barcodeUrl="http://supermarket.flexmarket.biz/database/insert_barcode.php";
	protected ProgressDialog dialogDB;
	protected String productName;
	protected String barcodeNumber;
	protected String amount;
	protected String units;
	protected String brandId;
	protected String productIsPacked;
	protected String productIsPackedItems;
	
/*	JSONObject last = null;
	JSONArray content = null;
	JSONObject last3 = null;
	private String myCoordinates[][];
	private String myCities[][];
	private String myMenu[][];
	*/
	public NewBarcodeCommunicate(Activity context,String proName,String barNumber,String am,String un,String brID,String prodIsPacked,String prodIsPackedItems) 
	{
		activityContext = context;
    	productName=new String(proName);
    	barcodeNumber=new String(barNumber);
    	amount=new String(am);
    	units=new String(un);
    	brandId=new String(brID);
    	productIsPacked=new String(prodIsPacked);
    	productIsPackedItems=new String(prodIsPackedItems);
	    
	}
	
	@Override
	 protected void onPreExecute()
	 {
		dialogDB = new ProgressDialog(activityContext);
		dialogDB = ProgressDialog.show(activityContext,activityContext.getResources().getText(R.string.wait_please),activityContext.getResources().getText(R.string.test_database), true);
		online=isOnline();
	 }
	
	/**
     * I check for connectivity with internet. It checks both for 3G and wifi connectivity 
     * If there is connectivity returns true
    */
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) activityContext.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}
	
	@Override
	protected Boolean doInBackground(String... urls)
	{
		if(online==true)
  	  	{
    	    try 
			{
    	    	barcodeUrl=barcodeUrl+"?pname="+productName+"&barcode="+barcodeNumber+"&amount="+amount+"&units="+units+"&brandid="+brandId+"&ispack="+productIsPacked+"&items="+productIsPackedItems;
    	    	barcodeUrl.replaceAll("\\s+", " ");
    	    	barcodeUrl=barcodeUrl.replace(' ', '+');
    	    	Log.v("TAG barcode url","barcode_url : "+barcodeUrl);
    	    	client= new DefaultHttpClient();
				url=new StringBuilder(barcodeUrl);
				get=new HttpGet(url.toString());
				
				r = client.execute(get);
				status=r.getStatusLine().getStatusCode();
				if(status==200)
				{
					try 
					{
						HttpEntity e=r.getEntity();
						String data =EntityUtils.toString(e);
						JSONArray	jsonData = new JSONArray("["+data+"]");
						JSONObject jsonObjects =jsonData.getJSONObject(0);
						int countRows=Integer.parseInt(jsonObjects.getString("total_rows"));
						if(countRows==0)
						{
							return false;
						}
						else
						{
							return true;
						}
					}
					catch (ClientProtocolException e1) 
					{
						
						
						return false;
					} 
					catch (IOException e1) 
					{
						
						
						return false;
					}
	        	    catch (JSONException e) {
						// TODO Auto-generated catch block
						return false;
					} 
					
				}
				else 
					return false;
				
			} 
			catch (ClientProtocolException e1) 
			{
				
				e1.printStackTrace();
				return false;
			} 
			catch (IOException e1) 
			{
				
				e1.printStackTrace();
				return false;
			} 
			
  	  	}
		else 
			return false;
			
	}
	
	@Override
    protected void onCancelled() 
	{
		dialogDB.dismiss();
    }

	@Override
    protected void onPostExecute(Boolean result)
    {
		/**
		 * Store both on server and locally
		 */
    	if(result==true)
		{
    		Log.v("TAG barcode url","barcode_url true ");
    		DatabaseCommunication ed=new DatabaseCommunication(activityContext);
			ed.storeProductsLocally(productName,barcodeNumber,productIsPacked,amount,productIsPackedItems,units,brandId,"true");
			
			ed.closeDB();
    		Toast.makeText(activityContext,R.string.store_succeed,Toast.LENGTH_SHORT).show();
		}
    	/**
		 * Store only locally. So the field is_stored_to_server will take value false. When app will have connectivity all products with values false at
		 * is_stored_to_server field will send to server 
		 */
    	else
    	{
    		Log.v("TAG barcode url","barcode_url false ");
    		DatabaseCommunication ed=new DatabaseCommunication(activityContext);
    		Cursor cursor=ed.retrieveSpecificProduct(barcodeNumber);
    		//If cursor.getCount()=0 this means that this product does not exist. so we will add it
    		if(cursor.getCount()==0)
    		{
    			ed.storeProductsLocally(productName,barcodeNumber,productIsPacked,amount,productIsPackedItems,units,brandId,"false");
    			Toast.makeText(activityContext,R.string.store_next_time,Toast.LENGTH_SHORT).show();
    		}
    		cursor.close();
			ed.closeDB();
			
    	}
    	dialogDB.dismiss();
    	
    	Intent intent = new Intent();
		intent.putExtra("returnKeyBarcode","ok");
		activityContext.setResult(Activity.RESULT_OK,intent);
		activityContext.finish();
    }

}



