package org.supermarket.gr;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;

/**
 * Σε αυτή τη κλάση γίνεται ο σχεδιασμός της φόρμας για τη συμπλήρωση των στοιχείων ενός προϊόντος. Στιγμιότυπα αυτής της κλάση δημιουργούνται 
 * από την BarcodeExistsInDB στη περίπτωση που σαρωθεί ένα προϊόν και δε βρεθεί αποθηκευμένο. 
 */
public class NewBarcodeUI extends Activity implements OnClickListener
{
	private String productName;
	private String barcodeNumber;
	private String amount;
	private String units;
	private String brandId;
	private String productIsPacked;
	private String productIsPackedItems;
	private Button insertProduct;
	
	protected EditText theProductName;
	protected EditText theAmount;
	protected Spinner theProductIsPacked;
	protected EditText theProductIsPackedItems;
	protected Spinner spinnerUnits;
	protected Spinner spinnerProductBrand;
	
	//protected Resources res;
	//protected ProgressDialog dialogDB;
	
		
	@Override
    public void onCreate(Bundle savedInstanceState) 
    {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.add_barcode);
		
		setUserInterface();
		Bundle extras = getIntent().getExtras();
		if(extras !=null) 
		{
			
			if(!extras.getString("productName").equals("nil") && !extras.getString("amount").equals("nil") && !extras.getString("unitsId").equals("nil") && !extras.getString("brandsId").equals("nil"))
			{
				theProductName.setText(extras.getString("productName"));
				theAmount.setText(extras.getString("amount"));
				theProductIsPackedItems.setText(extras.getString("productIsPackedItems"));
				//theProductIsPacked.setText(extras.getString("productIsPacked"));
				if(extras.getString("unitsId").equals("g"))
					spinnerUnits.setSelection(0);
				else if(extras.getString("unitsId").equals("kg"))
					spinnerUnits.setSelection(1);
				else if(extras.getString("unitsId").equals("mg"))
					spinnerUnits.setSelection(2);
				else if(extras.getString("unitsId").equals("lb"))
					spinnerUnits.setSelection(3);
				else if(extras.getString("unitsId").equals("oz"))
					spinnerUnits.setSelection(4);
				else if(extras.getString("unitsId").equals("l"))
					spinnerUnits.setSelection(5);
				else if(extras.getString("unitsId").equals("ml"))
					spinnerUnits.setSelection(6);
				else if(extras.getString("unitsId").equals("dg"))
					spinnerUnits.setSelection(7);
				else if(extras.getString("unitsId").equals("μg"))
					spinnerUnits.setSelection(8);
			}
			barcodeNumber = extras.getString("barcode");
			brandId= extras.getString("brandsId");
		}
    }
	
	
	 public void setUserInterface()
		{
			spinnerUnits = (Spinner) findViewById(R.id.units_system_spinner);
			// Create an ArrayAdapter using the string array and a default spinner layout
			ArrayAdapter<CharSequence> adapterUnits = ArrayAdapter.createFromResource(this, R.array.units_system_choices, android.R.layout.simple_spinner_item);
			// Specify the layout to use when the list of choices appears
			adapterUnits.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			// Apply the adapter to the spinner
			spinnerUnits.setAdapter(adapterUnits);
			//spinnerUnits.setOnItemSelectedListener(this);
			
			spinnerUnits.setOnItemSelectedListener(new OnItemSelectedListener() 
	  		  {

				public void onItemSelected(AdapterView<?> parent, View view,  int pos, long id)
				{
					// TODO Auto-generated method stub
					 if(pos==0)
			    		 units="2";
			    	 else if(pos==1)
			    		 units="3";
			    	 else if(pos==2)
			    		 units="4";
			    	 else if(pos==3)
			    		 units="5";
			    	 else if(pos==4)
			    		 units="6";
			    	 else if(pos==5)
			    		 units="7";
			    	 else if(pos==6)
			    		 units="8";
			    	 else if(pos==7)
			    		 units="9";
			    	 else if(pos==8)
			    		 units="10";
				}
				public void onNothingSelected(AdapterView<?> arg0) {
					// TODO Auto-generated method stub
					
				}
	  			  
	  		  }
	  		  );
			
			
			spinnerProductBrand = (Spinner) findViewById(R.id.product_brand_spinner);
			// Create an ArrayAdapter using the string array and a default spinner layout
			ArrayAdapter<CharSequence> adapterIsOffer = ArrayAdapter.createFromResource(this, R.array.product_brands, android.R.layout.simple_spinner_item);
			// Specify the layout to use when the list of choices appears
			adapterIsOffer.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			// Apply the adapter to the spinner
			spinnerProductBrand.setAdapter(adapterIsOffer);
			spinnerProductBrand.setOnItemSelectedListener(new OnItemSelectedListener() 
	  		  {
				public void onItemSelected(AdapterView<?> parent, View view,  int pos, long id)
				{
					String brandNamesIds[]={"49","44","29","1","16","23","34","38","2","47","30","3","19","35","41","28","36","24","12","4","5","48",
							"22","45","50","32","27","26","40","43","33","46","6","42","17","7","18","37","21","8","31","9","13","25","11","20","14","10"
							,"39","15","51"};
				
					brandId=brandNamesIds[pos];
							
					// TODO Auto-generated method stub
					//brandId= parent.getItemAtPosition(pos).toString();
				}

				public void onNothingSelected(AdapterView<?> arg0) {
					// TODO Auto-generated method stub
					
				}
	  		  }
	  		  );
			
			
			spinnerProductBrand = (Spinner) findViewById(R.id.product_is_packed_edx);
			// Create an ArrayAdapter using the string array and a default spinner layout
			ArrayAdapter<CharSequence> adapterIsPacked = ArrayAdapter.createFromResource(this, R.array.is_packed_array, android.R.layout.simple_spinner_item);
			// Specify the layout to use when the list of choices appears
			adapterIsPacked.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
			// Apply the adapter to the spinner
			spinnerProductBrand.setAdapter(adapterIsPacked);
			spinnerProductBrand.setOnItemSelectedListener(new OnItemSelectedListener() 
	  		  {
				public void onItemSelected(AdapterView<?> parent, View view,  int pos, long id)
				{
					if(pos==0)
						productIsPacked=new String("1");
			    	 else if(pos==1)
			    		 productIsPacked=new String("0");
				
							
					// TODO Auto-generated method stub
					//brandId= parent.getItemAtPosition(pos).toString();
				}

				public void onNothingSelected(AdapterView<?> arg0) {
					// TODO Auto-generated method stub
					
				}
	  		  }
	  		  );
			
			
			productName=new String();
			barcodeNumber=new String();
			amount=new String();
			units=new String();
			brandId=new String();
			productIsPacked=new String();
			productIsPackedItems=new String();
			insertProduct=(Button) findViewById(R.id.insert_new_barcode);
			insertProduct.setOnClickListener(this);
			
			theProductName=(EditText) findViewById(R.id.product_name_edx);
			theAmount=(EditText) findViewById(R.id.product_amount_edx);
			
			theProductIsPackedItems=(EditText) findViewById(R.id.product_items_edx);
			
	}
	
    public void onNothingSelected(AdapterView<?> parent) 
    {
        // Another interface callback
    }
    
    public void onClick(View v) 
	{
		 switch(v.getId())
	      {
		     case R.id.insert_new_barcode:
		    	  productName=theProductName.getText().toString();
		    	 
		    	  amount=theAmount.getText().toString();
		    	  amount=amount.replace(",", ".");
		    	//  productValue=theProductValue.getText().toString();
		    	 // productValue=productValue.replace(",", ".");
		    	  productIsPackedItems=theProductIsPackedItems.getText().toString();
		    	 
		    	  
		    	  Matcher matcherProductName;
			      Matcher matcherAmount;
			    //  Matcher matcherProductValue;
			      Matcher matcherProductIsPacked;
			         
			         
			      Pattern pattern1 = Pattern.compile("\\s");
			      matcherProductName = pattern1.matcher((CharSequence) productName);
			     // matcherProductValue = pattern1.matcher((CharSequence)  productValue);
			      matcherAmount = pattern1.matcher((CharSequence) amount);
			      matcherProductIsPacked = pattern1.matcher((CharSequence) productIsPacked);
			        
			      
			    //  if(!matcherProductName.find() && !matcherProductValue.find() && !matcherAmount.find() && !matcherProductIsPackedItems.find())
			    //if(!matcherProductValue.find() && !matcherAmount.find() && !matcherProductIsPackedItems.find())      
			      if(!matcherAmount.find() && !matcherProductIsPacked.find())
			      {
			    	  //if(productName!=null && productName.length()>0 &&  amount!=null && amount.length()>0) &&  productValue!=null && productValue.length()>0)
			    	  if(productName!=null && productName.length()>0 &&  amount!=null && amount.length()>0)
			    	  {
			    		  if(productIsPacked.length()==0 || productIsPacked==null)
				    		  productIsPacked="1";
				    	 
			    		 
			    		  NewBarcodeCommunicate task = new NewBarcodeCommunicate(this,productName,barcodeNumber,amount,units,brandId,productIsPacked,productIsPackedItems);
				    		task.execute(new String[] { "" });
			    	  }
			    	  else
			    	  {
			    		  Toast.makeText(this,R.string.field_not_edit,Toast.LENGTH_LONG).show();
			    	  }
			      }
			      else
			      {
			    	  Toast.makeText(this,R.string.no_white_characters,Toast.LENGTH_LONG).show();
			      }
		 		break;
	      }
	}
    
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}	
  
    public void onBackPressed()
	 {
    	Intent intent = new Intent();
    	intent.putExtra("returnKeyBarcode","back");
		setResult(RESULT_CANCELED,intent);
        finish();
    	
	 }
    
}
