package org.supermarket.gr;

import java.util.Calendar;
import java.util.ArrayList;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

/**
 *Στιγμιότυπα αυτής της κλάσης δημιουργούνται από την UserProductLists
 * όταν ο χρήστης επιλέξει τη δημιουργία νέας λίστας. Μέσω κατάλληλων 
 * κλήσεων της DatabaseCommunication γίνετε η αποθήκευση των επιλογών του χρήστη.
 * 
 * @return
 */
public class NewShoppingList extends Activity implements OnClickListener
{
	protected TextView barcodeScanView;
	protected TextView theNumberOfItems;
	protected Button newBarcodeBtn;
	protected EditText listNameEdt;
	
	//protected ProgressDialog dialogDB;
	//protected EnterpriseDatabase ed;
	//protected Resources res;
	protected String upc;
	protected ArrayList<String> barcodesOfTheList;
	protected ArrayList<String> barcodesOfTheListQuantity;
	protected ArrayList<String> barcodesDateOfTheList;
	protected String theUserID;
	int barcodesOfTheListIndex;
	public static final String USER_STORED = "User_stored";
	private final int SET_QUANTITIES_REQUEST_CODE=120;
	private final int ADD_BARCODE_REQUEST_CODE=121;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.new_shopping_list);
		
		barcodesOfTheListIndex=0;
		barcodesOfTheList= new ArrayList<String>( );
		barcodesOfTheListQuantity=new ArrayList<String>( );
		barcodesDateOfTheList= new ArrayList<String>( );
		Drawable img = this.getResources().getDrawable( R.drawable.scanning );
		img.setBounds( 0, 0, 50, 50 );
		
		barcodeScanView=(TextView)findViewById(R.id.add_list_txv1);
		theNumberOfItems=(TextView)findViewById(R.id.the_number_of_items_id);
		listNameEdt=(EditText)findViewById(R.id.add_list_edt);
		newBarcodeBtn=(Button)findViewById(R.id.new_barcodelist_button);
		
		barcodeScanView.setCompoundDrawables( null, null, img, null );
		barcodeScanView.setOnClickListener(this);
		newBarcodeBtn.setOnClickListener(this);
		
		//res = getResources();
		
		SharedPreferences current_session = getSharedPreferences(USER_STORED, 0);
        theUserID=new String();
    	theUserID = current_session.getString("user_id", "nill");
	}
	
	 public void onClick(View v)
	 {
	    	switch(v.getId())
	    	{
	    		case R.id.add_list_txv1:
	    			IntentIntegrator integrator = new IntentIntegrator(this);
	    			integrator.initiateScan();
	    			break;
	    		case R.id.new_barcodelist_button:
	    			
	    			final Calendar c = Calendar.getInstance();
	    			int year = c.get(Calendar.YEAR);
	    			int month = c.get(Calendar.MONTH);
	    			int day = c.get(Calendar.DAY_OF_MONTH);
	    			
	    			String currentYear=new String(day+"/"+month+"/"+year);
	    			
	    			DatabaseCommunication ed=new DatabaseCommunication(this);
	    			ed.createUserShoppingList(theUserID,listNameEdt.getText().toString(),currentYear);
	    			
	    			Cursor theCursor= ed.returnTheLastId("shopping_list","list_id");
	    			theCursor.moveToFirst();
	    			int theListID=theCursor.getInt(theCursor.getColumnIndexOrThrow("list_id"));
	    			theCursor.close();
	    			ed.addProductsToUserList(theListID,barcodesOfTheList,barcodesOfTheListQuantity);
	    			
	    			ed.closeDB();
	    			finish();
	    			break;
	    	}
	    }
	 
	 
		
	 
	 /**
	  * When the scanning of barcode completed this function will start. In the case the scanning result is ok,
	  * we will first check if this barcode exists at the database.
	  * Then we will add this barcode to the product list
	  */
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{
		switch (requestCode) 
        {
	        case ADD_BARCODE_REQUEST_CODE:
	        	if(resultCode == RESULT_OK) 
				{
		        	Intent quantities = new Intent(this,QuantitiesOfProductInList.class);
		        	quantities.putExtra("barcodescanned",upc);
				    startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
		        }
		        else
		        	Toast.makeText(this,R.string.edit_barcode_fields_p,Toast.LENGTH_SHORT).show();
		        
	        	break;
	        case SET_QUANTITIES_REQUEST_CODE: 
	        	if(resultCode == RESULT_OK) 
				{
	        		Bundle extras = intent.getExtras();
	    	        if(extras != null)
	    	        	barcodesOfTheListQuantity.add(extras.getString("quantityKey"));
	    	        else
	    	        	barcodesOfTheListQuantity.add("1");
		        }
		        else
		        	barcodesOfTheListQuantity.add("1");
	        	break;
	        default:
	        	IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, intent);
				  if (scanResult != null) 
				  {
					  upc = scanResult.getContents();
					  			//validBarcode=true;
							  if(resultCode == RESULT_OK) 
							  {
								  BarcodeExistsInDB task = new BarcodeExistsInDB(this,upc,"NewShoppingList");
								  task.execute(new String[] { "" });
								  
								  barcodesOfTheList.add(upc);
								  barcodesDateOfTheList.add("1");
								 // barcodesOfTheList[barcodesOfTheListIndex][0]=upc;
								 // barcodesOfTheList[barcodesOfTheListIndex][1]="1";
								  barcodesOfTheListIndex++;
								  theNumberOfItems.setText(barcodesOfTheListIndex +" items");
							  }
							  else if(resultCode == RESULT_CANCELED)
							  {
							  }
				  }
				  break;
        }
		
	} 
}
