package org.supermarket.gr;

import android.app.Activity;
import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

/**
 * Μέσω της QuantitiesOfProductInList είναι εφικτή η ενημέρωση 
 * της ποσότητας του κάθε προϊόντος μιας λίστας μέσω κατάλληλης γραφικής διεπαφής χρήστη. 
 */
public class QuantitiesOfProductInList extends Activity implements OnClickListener
{
	protected Resources res;
	protected EditText quantityOfProduct;
	protected Button storeQuantities;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.products_quantities);
		
		Bundle extras = getIntent().getExtras();
        if(extras != null)
        {
        	if(extras.getString("origin").equals("fridge"))
        	{
        		TextView txtv=(TextView)findViewById(R.id.quantity_product_list_or_fridge);
        		txtv.setText(R.string.quantity_of_product_in_fridge);
        	}
        	
        }
			
		setActions();
	}
	
	
	void setActions()
	{
		res = getResources();
		
		quantityOfProduct=(EditText) findViewById(R.id.quantity_of_product);
       
        storeQuantities=(Button) findViewById(R.id.store_quantity_of_product);
        storeQuantities.setOnClickListener(this);
        
	}
	
	
	public void onClick(View v) 
	{
		 Intent intent = new Intent();
		 intent.putExtra("quantityKey",quantityOfProduct.getText().toString());
		 setResult(RESULT_OK,intent);
		 finish();
	}
	
	 public void onBackPressed()
	 {
		 Intent intent = new Intent();
		 intent.putExtra("quantityKey","1");
		 setResult(RESULT_CANCELED,intent);
		 finish();
	 }
}