package org.supermarket.gr;

import java.io.IOException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.util.Log;

/**
 * Στιγμιότυπα αυτής της κλάσης δημιουργούνται από την SuperMarketInMap με σκοπό την 
 * αποστολή των δεδομένων των χρηστών στη κεντρική βάση. Στη κλάση αυτή στήνεται η 
 * επικοινωνία με τον διακομιστή κεντρική στον οποίο βρίσκεται η βάση και καλούνται οι 
 * κατάλληλες web υπηρεσίες για την αποθήκευση των δεδομένων.
 */
public class SendUpdatesToServerDatabase extends AsyncTask<String, Void,Boolean> 
{
	private Activity activityContext;
	protected boolean online;
	protected HttpGet get;
	protected HttpResponse r;
	protected int status;
	HttpClient client;
	StringBuilder url;
	protected String baseBarcodeUrl="http://supermarket.flexmarket.biz/database/insert_barcode.php";
	protected String barcodeUrl;
	protected DatabaseCommunication ed;
	/**
     * Δισδιάτος πίνακας που αποθηκεύει τα δεδομένα της τοπικής βάσης δεδομένων που δεν έχουν σταλθεί στη κεντρική βάση δεδομένων.
    */
	protected String[][] incompleteRequests;
	
	public SendUpdatesToServerDatabase(Activity context) 
	{
		activityContext = context;
	    
	}
	
	/*
     * I check for connectivity with internet. It checks both for 3G and wifi connectivity 
     * If there is connectivity returns true
    */
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) activityContext.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}
	
	@Override
	 protected void onPreExecute()
	 {
		online=isOnline();
		
 	    ed=new DatabaseCommunication(activityContext);
 	    barcodeUrl=new String();
	 }
	
	@Override
	protected Boolean doInBackground(String... urls)
	{
		if(online==true)
  	  	{
			for(int i=0;i<incompleteRequests.length;i++)
			{
				System.out.println("incompleteRequests : "+ incompleteRequests[i][0]);
				
				 try 
				{
					 	barcodeUrl="";
	        	    	barcodeUrl=baseBarcodeUrl+"?pname="+incompleteRequests[i][0]+"&barcode="+incompleteRequests[i][1]+"&sname="+incompleteRequests[i][2]+"&amount="+incompleteRequests[i][3]+"&units="+incompleteRequests[i][4]+"&isoffer="+incompleteRequests[i][5]+"&ispack="+incompleteRequests[i][6]+"&items="+incompleteRequests[i][7]+"&product_value="+incompleteRequests[i][8];
	        	    	
	        	    	barcodeUrl.replaceAll("\\s+", " ");
	        	    	barcodeUrl=barcodeUrl.replace(' ', '+');
	        	    	
	        	    	Log.i("SuperMarketActivity", "barcodeUrl : "+barcodeUrl);
	        	    	
	        	    	client= new DefaultHttpClient();
						url=new StringBuilder(barcodeUrl);
						get=new HttpGet(url.toString());
						
						r = client.execute(get);
						
						status=r.getStatusLine().getStatusCode();
						if(status==200)
						{
							//delete the request from database because I send product to server successfully
							Log.i("SuperMarketActivity", "incomplete : "+incompleteRequests[i][1]);
							
							ed.changeStateOfNoSentProducts(incompleteRequests[i][1]);
							continue;
						}
						else 
							continue;
						
					} 
					catch (ClientProtocolException e1) 
					{
						
						e1.printStackTrace();
						continue;
					} 
					catch (IOException e1) 
					{
						
						e1.printStackTrace();
						continue;
					}
			}
			return true;
			
  	  	}
		else 
			return false;
			
	}
	
	@Override
    protected void onCancelled() 
	{
		
    }

	@Override
    protected void onPostExecute(Boolean result)
    {
		ed.closeDB();
    	
    	Intent firstActivity = new Intent(activityContext,MainActivityUI.class);
    	activityContext.startActivity(firstActivity);
        activityContext.finish();
    }

}
