package org.supermarket.gr;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Locale;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.supermarket.gr.UserProductLists.MyExpandableListAdapter;

import android.annotation.SuppressLint;
import android.app.ActionBar.LayoutParams;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.Fragment;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.provider.Settings;
import android.content.res.Resources;
import android.database.Cursor;
import android.graphics.Point;
import android.location.Address;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Display;
import android.view.Gravity;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.View.OnClickListener;
import android.widget.AbsListView;
import android.widget.BaseExpandableListAdapter;
import android.widget.Button;
import android.widget.ExpandableListAdapter;
import android.widget.ExpandableListView;
import android.widget.TableLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ExpandableListView.ExpandableListContextMenuInfo;
import android.widget.ViewFlipper;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

/**
 * Η κλάση αυτή μέσω του map API της Google βρίσκει 
 * τις συντεταγμένες του χρήση και σχεδιάζει τη γραφική διεπαφή που 
 * περιλαμβάνει το χάρτη με τα σημεία τα οποία αντιστοιχούν σε supermarket. 
 * Επίσης δίνει τη δυνατότητα να οριστεί η απόσταση αναζήτησης supermarket. Τέλος σχεδιάζει το GUI για την παρουσίαση των τιμών της λίστας που επιλέχτηκε ανά supermarket αλλά και ανά ζεύγη supermarket. 
 */
public class SuperMarketInMap extends FragmentActivity implements OnClickListener
{
   // private TextView mLatLng;
    private TextView mAddress;
    private int distanceFromMe;
    private LocationManager mLocationManager;
    private Handler mHandler;
    private boolean mGeocoderAvailable;
    // UI handler codes.
	protected Resources res;
    private static final int UPDATE_ADDRESS = 1;
    private static final int UPDATE_LATLNG = 2;
    protected ProgressDialog dialogDB;
    private int isFirstTimeOfSearchSuper;
    private static final int TEN_SECONDS = 30000; //30 sec
    private static final int TEN_METERS = 100;		//100 meters
    private static final int TWO_MINUTES = 1000 * 60 * 2;
    protected String theSelectedListId;
    protected ArrayList<String> latitudeOfPoint;
	protected ArrayList<String> longitudeOfPoint;
	protected ArrayList<String> nameOfPoint;
	protected ArrayList<String> addressOfPoint;
	protected ExpandableListView theExList;
	protected ExpandableListView theExList1;
	protected ArrayList<String> idOfPoint;
	protected ArrayList<String> productNamesList;
	protected ArrayList<String> amountOfProductInList;
	protected String currentViewDisplay;
	//protected ArrayList<String> barcodesOfList;
	protected String barcodesOfList[];
	protected String productsAndPrices[][];
	protected GoogleMap mMap;
	protected Context context;
	protected TableLayout tblmap;
	protected TableLayout tbladdress;
	protected Button changeRangeBtn;
	protected Button showAllPrices;
	protected Button combineSupermarkets;
	protected TableLayout tblrange;
	protected Location lastKnownUserLocation;
	private ViewFlipper vf;
	
	public SupermarketCombination superComb;
	
	ExpandableListAdapter mAdapter;
	ExpandableListAdapter mAdapter1;
    protected String[] supermarketsNameAndAddress;
    protected String[][] productPrices;
	
    @SuppressLint("NewApi")
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.map_layout);
        
        vf=(ViewFlipper)findViewById(R.id.ViewFlipper01);
        vf.setDisplayedChild(0);
        
        currentViewDisplay=new String("map");
        tblmap=(TableLayout)findViewById(R.id.tblmap);
        tbladdress=(TableLayout)findViewById(R.id.tbladdress);
        tblrange=(TableLayout)findViewById(R.id.tblrange);
        
        android.view.ViewGroup.LayoutParams paramsMap =  tblmap.getLayoutParams();
        android.view.ViewGroup.LayoutParams paramsAddress =  tbladdress.getLayoutParams();
        android.view.ViewGroup.LayoutParams paramsRange = tblrange.getLayoutParams();
        
        if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB)
		{
        	Display display = getWindowManager().getDefaultDisplay();
            Point size = new Point();
            display.getSize(size);
            int height = size.y;
            
           
         // Changes the height and width to the specified *pixels*
            paramsMap.height = height-paramsAddress.height-paramsRange.height;
		}
		else
		{
			Display display = getWindowManager().getDefaultDisplay(); 
	        int height = display.getHeight();
	        // Changes the height and width to the specified *pixels*
            paramsMap.height = height-paramsAddress.height-paramsRange.height-100;
		}
        
        isFirstTimeOfSearchSuper=0;
        changeRangeBtn=(Button)findViewById(R.id.change_range_btn);
        changeRangeBtn.setOnClickListener(this);
        changeRangeBtn.setOnCreateContextMenuListener(this);
        
        showAllPrices=(Button)findViewById(R.id.show_all_values);
        showAllPrices.setOnClickListener(this);
        showAllPrices.setEnabled(false);
        
        combineSupermarkets=(Button)findViewById(R.id.combine_supermarket_values);
        combineSupermarkets.setOnClickListener(this);
        combineSupermarkets.setEnabled(false);
        
        
        Bundle extras = getIntent().getExtras();
		if(extras !=null) 
			theSelectedListId=new String(extras.getString("selected_list_id"));
		else
			theSelectedListId=new String();
		
		distanceFromMe=1;
		
		 res = getResources();
		 
		 
		 DatabaseCommunication ed=new DatabaseCommunication(this);
		 
		 //einai to ilektroniko psygeio
		 Cursor theCursor;
		 Log.v("TAG theSelectedListId",theSelectedListId);
		 if(theSelectedListId.equals("1"))
		 {
			 Log.v("TAG mpike","mpike");
			 theCursor=ed.retrieveNoStockProductsInFridge(theSelectedListId);
		 }
		 else
			 theCursor=ed.retrieveProductsOfShoppingList(theSelectedListId);
		 
		barcodesOfList=new String[theCursor.getCount()];
		productNamesList=new ArrayList<String>( );
		amountOfProductInList=new ArrayList<String>( );
		int counterB=0;
		while(theCursor.moveToNext())
		{
			String barc=new String(theCursor.getString(theCursor.getColumnIndexOrThrow("barcode")));
			String barcName=new String(theCursor.getString(theCursor.getColumnIndexOrThrow("pname")));
			barcodesOfList[counterB]=barc;
			productNamesList.add(counterB, barcName);
			String amountString;
			if(theSelectedListId.equals("1"))
				amountString=new String(theCursor.getString(theCursor.getColumnIndexOrThrow("number_of_purchase")));
			else
				amountString=new String(theCursor.getString(theCursor.getColumnIndexOrThrow("product_amount")));
			amountOfProductInList.add(counterB, amountString);
			counterB++;
		}
			
			theCursor.close();
			ed.closeDB();
		 
		 
      //  mLatLng = (TextView) findViewById(R.id.latlng);
        mAddress = (TextView) findViewById(R.id.address);

        // The isPresent() helper method is only available on Gingerbread or above.
        mGeocoderAvailable =Build.VERSION.SDK_INT >= Build.VERSION_CODES.GINGERBREAD && Geocoder.isPresent();

        // Handler for updating text fields on the UI like the lat/long and address.
        mHandler = new Handler() 
        {
            public void handleMessage(Message msg) 
            {
                switch (msg.what) 
                {
                    case UPDATE_ADDRESS:
                        mAddress.setText((String) msg.obj);
                        break;
                    case UPDATE_LATLNG:
                        //mLatLng.setText((String) msg.obj);
                        break;
                }
            }
        };
        // Get a reference to the LocationManager object.
        mLocationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
    }

    @Override
    protected void onResume() {
        super.onResume();
        setup();
    }

    @Override
    protected void onStart() 
    {
        super.onStart();

        // Check if the GPS setting is currently enabled on the device.
        // This verification should be done during onStart() because the system calls this method
        // when the user returns to the activity, which ensures the desired location provider is
        // enabled each time the activity resumes from the stopped state.
        LocationManager locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
        final boolean gpsEnabled = locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER);

        if (!gpsEnabled) 
        {
            // Build an alert dialog here that requests that the user enable
            // the location services, then when the user clicks the "OK" button,
            // call enableLocationSettings()
          //  new EnableGpsDialogFragment().show(getSupportFragmentManager(), "enableGpsDialog");
        	DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() 
        	{
        	    public void onClick(DialogInterface dialog, int which) 
        	    {
        	        switch (which)
        	        {
        	        case DialogInterface.BUTTON_POSITIVE:
        	        	enableLocationSettings();
        	            break;

        	        case DialogInterface.BUTTON_NEGATIVE:
        	            //No button clicked
        	        	//finish();
        	            break;
        	        }
        	    }
        	};

        	AlertDialog.Builder builder = new AlertDialog.Builder(this);
        	builder.setMessage("Maybe you want to enable GPS?").setPositiveButton("Yes", dialogClickListener).setNegativeButton("No", dialogClickListener).show();
        
       
        	//new EnableGpsDialogFragment().show(getSupportFragmentManager(), "enableGpsDialog");
        }
    }

    // Method to launch Settings
    private void enableLocationSettings() 
    {
        Intent settingsIntent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
        startActivity(settingsIntent);
    }

    // Stop receiving location updates whenever the Activity becomes invisible.
    @Override
    protected void onStop() 
    {
        super.onStop();
        mLocationManager.removeUpdates(listener);
    }

    // Set up fine and/or coarse location providers depending on whether the fine provider or
    // both providers button is pressed.
    private void setup() 
    {
        Location gpsLocation = null;
        Location networkLocation = null;
        mLocationManager.removeUpdates(listener);
       // mLatLng.setText(R.string.a);
        mAddress.setText(R.string.address);
        // Get fine location updates only.
        
        // Request updates from both fine (gps) and coarse (network) providers.
            gpsLocation = requestUpdatesFromProvider(
                    LocationManager.GPS_PROVIDER, R.string.not_support_gps);
            networkLocation = requestUpdatesFromProvider(
                    LocationManager.NETWORK_PROVIDER, R.string.not_support_network);

            // If both providers return last known locations, compare the two and use the better
            // one to update the UI.  If only one provider returns a location, use it.
            if (gpsLocation != null && networkLocation != null) 
                updateUILocation(getBetterLocation(gpsLocation, networkLocation));
            else if (gpsLocation != null) 
                updateUILocation(gpsLocation);
            else if (networkLocation != null) 
                updateUILocation(networkLocation);
        
    }

    /**
     * Method to register location updates with a desired location provider.  If the requested
     * provider is not available on the device, the app displays a Toast with a message referenced
     * by a resource id.
     *
     * @param provider Name of the requested provider.
     * @param errorResId Resource id for the string message to be displayed if the provider does
     *                   not exist on the device.
     * @return A previously returned {@link android.location.Location} from the requested provider,
     *         if exists.
     */
    private Location requestUpdatesFromProvider(final String provider, final int errorResId) 
    {
        Location location = null;
        if (mLocationManager.isProviderEnabled(provider)) 
        {
            mLocationManager.requestLocationUpdates(provider, TEN_SECONDS, TEN_METERS, listener);
            location = mLocationManager.getLastKnownLocation(provider);
        } 
        else 
        {
            Toast.makeText(this, errorResId, Toast.LENGTH_LONG).show();
        }
        return location;
    }


    private void doReverseGeocoding(Location location)
    {
        // Since the geocoding API is synchronous and may take a while.  You don't want to lock
        // up the UI thread.  Invoking reverse geocoding in an AsyncTask.
        (new ReverseGeocodingTask(this)).execute(new Location[] {location});
    }

    private void updateUILocation(Location location) 
    {
        // We're sending the update to a handler which then updates the UI with the new
        // location.
        Message.obtain(mHandler,UPDATE_LATLNG, location.getLatitude() + ", " + location.getLongitude()).sendToTarget();
        // Bypass reverse-geocoding only if the Geocoder service is available on the device.
        if (mGeocoderAvailable) 
        	doReverseGeocoding(location);
        
        
      
        
        
    }
    
    public boolean isOnline() 
	 {
		 boolean connected = false;
	
		ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo ni = cm.getActiveNetworkInfo();
			
		if (ni!=null && ni.isAvailable() && ni.isConnected()) 
		{
			connected=true;
		} 
		else 
		{
			connected=false; 
		}
		return connected;
	}	

    private final LocationListener listener = new LocationListener()
    {

        public void onLocationChanged(Location location) {
            // A new location update is received.  Do something useful with it.  Update the UI with
            // the location update.
        	  //edw tha vriskw perioxes
        	lastKnownUserLocation=new Location(location);
            AskForSupermarketCoordinates ctask = new AskForSupermarketCoordinates(context,location.getLatitude(),location.getLongitude());
            ctask.execute(new String[] { "" });
            updateUILocation(location);
        }

        public void onProviderDisabled(String provider) {
        }

        public void onProviderEnabled(String provider) {
        }

        public void onStatusChanged(String provider, int status, Bundle extras) {
        }
    };

    /** Determines whether one Location reading is better than the current Location fix.
      * Code taken from
      * http://developer.android.com/guide/topics/location/obtaining-user-location.html
      *
      * @param newLocation  The new Location that you want to evaluate
      * @param currentBestLocation  The current Location fix, to which you want to compare the new
      *        one
      * @return The better Location object based on recency and accuracy.
      */
    protected Location getBetterLocation(Location newLocation, Location currentBestLocation) {
        if (currentBestLocation == null) {
            // A new location is always better than no location
            return newLocation;
        }

        // Check whether the new location fix is newer or older
        long timeDelta = newLocation.getTime() - currentBestLocation.getTime();
        boolean isSignificantlyNewer = timeDelta > TWO_MINUTES;
        boolean isSignificantlyOlder = timeDelta < -TWO_MINUTES;
        boolean isNewer = timeDelta > 0;

        // If it's been more than two minutes since the current location, use the new location
        // because the user has likely moved.
        if (isSignificantlyNewer) {
            return newLocation;
        // If the new location is more than two minutes older, it must be worse
        } else if (isSignificantlyOlder) {
            return currentBestLocation;
        }

        // Check whether the new location fix is more or less accurate
        int accuracyDelta = (int) (newLocation.getAccuracy() - currentBestLocation.getAccuracy());
        boolean isLessAccurate = accuracyDelta > 0;
        boolean isMoreAccurate = accuracyDelta < 0;
        boolean isSignificantlyLessAccurate = accuracyDelta > 200;

        // Check if the old and new location are from the same provider
        boolean isFromSameProvider = isSameProvider(newLocation.getProvider(),
                currentBestLocation.getProvider());

        // Determine location quality using a combination of timeliness and accuracy
        if (isMoreAccurate)
        {
            return newLocation;
        }
        else if (isNewer && !isLessAccurate) 
        {
            return newLocation;
        } 
        else if (isNewer && !isSignificantlyLessAccurate && isFromSameProvider)
        {
            return newLocation;
        }
        return currentBestLocation;
    }

    /** Checks whether two providers are the same */
    private boolean isSameProvider(String provider1, String provider2) 
    {
        if (provider1 == null) 
        {
          return provider2 == null;
        }
        return provider1.equals(provider2);
    }

    // AsyncTask encapsulating the reverse-geocoding API.  Since the geocoder API is blocked,
    // we do not want to invoke it from the UI thread.
    private class ReverseGeocodingTask extends AsyncTask<Location, Void, Void> 
    {
        Context mContext;

        public ReverseGeocodingTask(Context context) 
        {
            super();
            mContext = context;
        }

        @Override
        protected Void doInBackground(Location... params) 
        {
            Geocoder geocoder = new Geocoder(mContext, Locale.getDefault());

            Location loc = params[0];
            List<Address> addresses = null;
            try 
            {
                addresses = geocoder.getFromLocation(loc.getLatitude(), loc.getLongitude(), 1);
            } 
            catch (IOException e) 
            {
                e.printStackTrace();
                // Update address field with the exception.
                Message.obtain(mHandler, UPDATE_ADDRESS, e.toString()).sendToTarget();
            }
            if (addresses != null && addresses.size() > 0) 
            {
                Address address = addresses.get(0);
                // Format the first line of address (if available), city, and country name.
                String addressText = String.format("%s, %s, %s",
                        address.getMaxAddressLineIndex() > 0 ? address.getAddressLine(0) : "",
                        address.getLocality(),
                        address.getCountryName());
                // Update address field on UI.
                Message.obtain(mHandler, UPDATE_ADDRESS, addressText).sendToTarget();
            }
            return null;
        }
    } 
    
    @Override
    public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) 
    {
        menu.setHeaderTitle("Distance from me");
        menu.add(0, 0, 0, "1kmh");
        menu.add(0, 1, 0, "10 kmh");
        menu.add(0, 2, 0, "20kmh");
    }
    
    @Override
    public boolean onContextItemSelected(MenuItem item) 
    {
        
        	if(item.getItemId()==0)
        	{
        		distanceFromMe=1;
        	}
        	if(item.getItemId()==1)
        	{
        		distanceFromMe=10;
        	}
        	else if(item.getItemId()==2)
        	{
        		distanceFromMe=20;
        	}
        	
        	if(lastKnownUserLocation!=null)
        	{
        		AskForSupermarketCoordinates ctask = new AskForSupermarketCoordinates(context,lastKnownUserLocation.getLatitude(),lastKnownUserLocation.getLongitude());
                ctask.execute(new String[] { "" });
                //updateUILocation(location);
        	}
        	
            
            return true;
    }
    
    /**
     * Dialog to prompt users to enable GPS on the device.
     */
    public class EnableGpsDialogFragment extends DialogFragment 
    {
    	
        @Override
        public Dialog onCreateDialog(Bundle savedInstanceState) 
        {
            return new AlertDialog.Builder(getActivity()).setTitle(R.string.enable_gps).setMessage(R.string.enable_gps_dialog)
                    .setPositiveButton(R.string.enable_gps, new DialogInterface.OnClickListener() 
                    {
                      
                        public void onClick(DialogInterface dialog, int which) 
                        {
                            enableLocationSettings();
                        }
                    }).create();
        }
    }
    
    
    private class AskForSupermarketCoordinates extends AsyncTask<String, Void, Integer> 
	{
		private Context context;
		protected boolean online;
		protected HttpPost post;
		protected HttpGet getMethod;
		protected HttpResponse r;
		protected int status;
		HttpClient client;
		StringBuilder url;
		//user_lat=39.6380838&user_lng=22.4299338&rad=0.7
		protected String barcodeUrl="http://supermarket.flexmarket.biz/database/find_super_nearme.php?";
		JSONObject jsonObjects = null;
		JSONArray content = null;
		JSONArray contentPrices = null;
		JSONObject superJSON = null;
		JSONObject productsJSON = null;
		JSONObject last=null;
		double theLat;
		double theLon;
		
		public AskForSupermarketCoordinates(Context context,double lat,double lon) 
		{
			this.context = context;
		    theLat=lat;
		    theLon=lon;
		}
		
		@Override
		 protected void onPreExecute()
		 {
			if(isFirstTimeOfSearchSuper==0)
				dialogDB = ProgressDialog.show(SuperMarketInMap.this,res.getText(R.string.wait_please), res.getText(R.string.test_database), true);
			online=isOnline();
			initializeDataStructures();
		 }
		
		protected void initializeDataStructures()
		{
			productsAndPrices=null;
			latitudeOfPoint=null;
			longitudeOfPoint=null;
			addressOfPoint=null;
			nameOfPoint=null;
			idOfPoint=null;
			//productNamesList=null;
			latitudeOfPoint= new ArrayList<String>( );
			longitudeOfPoint= new ArrayList<String>( );
			nameOfPoint= new ArrayList<String>( );
			addressOfPoint= new ArrayList<String>( );
			idOfPoint=new ArrayList<String>( );
			//productNamesList=new ArrayList<String>( );
			
		}
		
		@Override
		protected Integer doInBackground(String... urls)
		{
			if(online==true)
     	  	{
				try 	
				{
					//client= new DefaultHttpClient();
					//url=new StringBuilder(barcodeUrl);
					/*post=new HttpPost(url.toString());
					
					List<NameValuePair> value=new ArrayList<NameValuePair>();
			        value.add(new BasicNameValuePair("user_lat",Double.toString(theLat)));
			        value.add(new BasicNameValuePair("user_lng",Double.toString(theLon)));
			        value.add(new BasicNameValuePair("rad",Integer.toString(distanceFromMe)));
			        
					for(int i=0;i<barcodesOfList.length;i++)
					{
						value.add(new BasicNameValuePair("barcode"+i, barcodesOfList[i]));
					}
					value.add(new BasicNameValuePair("array_length",Integer.toString(barcodesOfList.length)));
			        
			        UrlEncodedFormEntity entity=new UrlEncodedFormEntity(value);
			        post.setEntity(entity);
			        r = client.execute(post);
					status=r.getStatusLine().getStatusCode();
					*/
					
	       	    	barcodeUrl=barcodeUrl+"user_lat="+theLat+"&user_lng="+theLon+"&rad="+distanceFromMe;
	       	    	for(int i=0;i<barcodesOfList.length;i++)
					{
	       	    		barcodeUrl=barcodeUrl+"&barcode"+i+"="+barcodesOfList[i];
						
					}
	       	    	barcodeUrl=barcodeUrl+"&array_length="+Integer.toString(barcodesOfList.length);
	       	    	
	       	    	Log.v("TAG barcode array url","barcode array url : " +barcodesOfList);
	       	    	Log.v("TAG barcode url","barcode url : " +barcodeUrl);
	       	    	
       	    		client= new DefaultHttpClient();
					url=new StringBuilder(barcodeUrl);
					getMethod=new HttpGet(url.toString());
					r = client.execute(getMethod);
					status=r.getStatusLine().getStatusCode();
					if(status==200)
					{
						HttpEntity e=r.getEntity();
						String data =EntityUtils.toString(e);
						JSONArray	jsonData = new JSONArray("["+data+"]");
						jsonObjects =jsonData.getJSONObject(0);
						int countRows=Integer.parseInt(jsonObjects.getString("total_rows"));
						last =jsonData.getJSONObject(0);
						
						if(countRows>0)
							content =last.getJSONArray("supermarkets");
						else
							return 5;
						
						int countPricesRows=Integer.parseInt(jsonObjects.getString("total_prices_rows"));
						if(countPricesRows>0)
							contentPrices=last.getJSONArray("products");
						else
							contentPrices=null;
						
						productsAndPrices=new String[countRows][barcodesOfList.length+1];
						//arxikopoihsh. Otan einai nil shmainei den yparxei timi
						for(int i=0;i<countRows;i++)
						{
							for(int k=0;k<barcodesOfList.length+1;k++)
							{
								productsAndPrices[i][k]=res.getString(R.string.product_no_available);
								//productNamesList.add("nil");
							}
						}
						
						for (int i = 0; i < countRows; i++) 
					    {
							superJSON=(JSONObject) content.get(i);
							
							if(superJSON.isNull("name"))
								nameOfPoint.add("null");
							else
								nameOfPoint.add(superJSON.getString("name"));
							
							if(superJSON.isNull("id"))
								idOfPoint.add("null");
							else
								idOfPoint.add(superJSON.getString("id"));
							
							if(superJSON.isNull("address"))
								addressOfPoint.add("null");
							else
								addressOfPoint.add(superJSON.getString("address"));
							
							if(superJSON.isNull("lat"))
								latitudeOfPoint.add("null");
							else
								latitudeOfPoint.add(superJSON.getString("lat"));
							
							if(superJSON.isNull("lng"))
								longitudeOfPoint.add("null");
							else
								longitudeOfPoint.add(superJSON.getString("lng"));
							
							
							
							
							double totalPrice=0.0;
							//Diasxizw to JSON me ta prices
							for (int j = 0; j< countPricesRows; j++) 
						    {
								productsJSON=(JSONObject) contentPrices.get(j);
								if(productsJSON.isNull("superid"))
									continue;
								//Vrika gia to supermarket (i) pou diavazw twra kataxwrisi sto JSON me ta prices
								else if(productsJSON.getString("superid").equals(idOfPoint.get(i)))
								{
									//Diasxizw ton pinaka me ta barcodes wspou na vrw to index tou sygkekrimenou barcode
									for(int k=0;k<barcodesOfList.length;k++)
									{
										//vrika to index
										if(productsJSON.getString("barcode").equals(barcodesOfList[k]))
										{
											//i is the number of supermarket and k the number of product
											//productNamesList.add(k, productsJSON.getString("offer_product_name"));
											productsAndPrices[i][k]=productsJSON.getString("price");
											//hasBarcodePrice=1;
											double aDouble = Double.parseDouble(productsAndPrices[i][k]);
											totalPrice=totalPrice+aDouble;
											Log.v("TAG barcode total price ","total price : " +totalPrice);
										}
									}
									
									
								}
						    }
							
							
							if(contentPrices!=null)
							{
								if(totalPrice!=0)
									productsAndPrices[i][barcodesOfList.length]=Double.toString(totalPrice);
								else
									productsAndPrices[i][barcodesOfList.length]=res.getString(R.string.product_no_available);
								
							}
							else
								productsAndPrices[i][barcodesOfList.length]=res.getString(R.string.product_no_available);
							productNamesList.add(barcodesOfList.length, "Total");
							
							
					    }	
					}
					else 
					{
						Log.v("TAG barcode url","3 : error");
						return 3;
					}
				} 
				catch (ClientProtocolException e1) 
				{
					Log.v("TAG barcode url","3 : error");
					e1.printStackTrace();
					return 3;
				} 
				catch (IOException e1) 
				{
					Log.v("TAG barcode url","3 : error");
					e1.printStackTrace();
					return 3;
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					Log.v("TAG barcode url","3 : error");
					e.printStackTrace();
					return 3;
				} 
				return 1;
				
     	  	}
			else 
			{
				return 4;
			}
				
		}
		
		@Override
	    protected void onCancelled() 
		{
			if(isFirstTimeOfSearchSuper==0)
				dialogDB.dismiss();
	    }

		@SuppressLint("NewApi")
		@Override
	    protected void onPostExecute(Integer result)
	    {
	    	if(result==1)
			{
	    		
	    		if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB)
	    		{
	    			mMap = ((MapFragment)getFragmentManager().findFragmentById(R.id.map)).getMap();
	    			mMap.clear();
		    		for(int i=0;i<nameOfPoint.size();i++)
		    		{
		    			double iLat=Double.parseDouble(latitudeOfPoint.get(i));
		    			double iLon=Double.parseDouble(longitudeOfPoint.get(i));
		    			mMap.addMarker(new MarkerOptions().position(new LatLng(iLat,iLon)).title(nameOfPoint.get(i)).snippet("Total value : "+productsAndPrices[i][barcodesOfList.length]));
		    		
		    		}
	    		}
	    		else
	    		{
	    			mMap = ((SupportMapFragment)getSupportFragmentManager().findFragmentById(R.id.map)).getMap();
		    		mMap.clear();
		    		for(int i=0;i<nameOfPoint.size();i++)
		    		{
		    			double iLat=Double.parseDouble(latitudeOfPoint.get(i));
		    			double iLon=Double.parseDouble(longitudeOfPoint.get(i));
		    			if(productsAndPrices.length>i)
		    					mMap.addMarker(new MarkerOptions().position(new LatLng(iLat,iLon)).title(nameOfPoint.get(i)).snippet("Total value : "+productsAndPrices[i][barcodesOfList.length]));
		    			LatLng myPosition = new LatLng(iLat, iLon);
		    			mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(myPosition, 14));
			    		mMap.setMyLocationEnabled(true);
		    		}
	    		}
	    		showAllPrices.setEnabled(true);
	    		combineSupermarkets.setEnabled(true);
	    		
	    		// android.support.v4.app.MapFragment ssmf=getSupportFragmentManager().findFragmentById(R.id.map);
	    		// mMap=((android.support.v4.app.Fragment) getFragmentManager().findFragmentById(R.id.map)).getMap();
	             //mapObject.addMarker(new MarkerOptions()
	            // .position(new LatLng(32.1275701, 34.7983432))
	            // .title("Hello world"));
			}
	    	else if(result==0)
	    	{
	    		
	    	}
	    	else if(result==2)
	    	{
	  
	    	}
	    	else if(result==3)
	    	{
	    		
	    	}
	    	else if(result==5)
	    	{
	    		
	    	}
	    	if(isFirstTimeOfSearchSuper==0)
	    	{
	    		dialogDB.dismiss();
	    		isFirstTimeOfSearchSuper=1;
	    	}
	    		
	    }

	}

	public void onClick(View v) 
	{
		// TODO Auto-generated method stub
		switch(v.getId())
	      {
		     case R.id.change_range_btn:
		    	 this.openContextMenu(v);
		    	 break;
		     case R.id.combine_supermarket_values:
		    	 SupermarketsAndPricesStaticClass.setProductsAndPrices(productsAndPrices);
		    	 SupermarketsAndPricesStaticClass.setSupermarketsAddress(addressOfPoint);
		    	 SupermarketsAndPricesStaticClass.setSupermarketsNames(nameOfPoint);
		    	 SupermarketsAndPricesStaticClass.setProductsNames(productNamesList);
		    	 SupermarketsAndPricesStaticClass.setAmountOfProduct(amountOfProductInList); 
		    	 
		    	 
		    	 superComb=new SupermarketCombination(nameOfPoint,productNamesList);
		    	 superComb.allSuperCombination();
		    	 
		    	 
		    	 
		    	 
		    	 
		    	//setContentView(R.layout.all_prices);
		         vf.setDisplayedChild(2);
		         currentViewDisplay="prices";
		         theExList1=(ExpandableListView)findViewById(R.id.expandablelist2);
		         // Set up our adapter
		         mAdapter1 = new MyExpandableListAdapter1();
		         theExList1.setAdapter(mAdapter1);
		    	 break;
		     case R.id.show_all_values:
		    	  
		    	 SupermarketsAndPricesStaticClass.setProductsAndPrices(productsAndPrices);
		    	 SupermarketsAndPricesStaticClass.setSupermarketsAddress(addressOfPoint);
		    	 SupermarketsAndPricesStaticClass.setSupermarketsNames(nameOfPoint);
		    	 SupermarketsAndPricesStaticClass.setProductsNames(productNamesList);
		    	 SupermarketsAndPricesStaticClass.setAmountOfProduct(amountOfProductInList);
		    	/* Intent allSuperPr=new Intent(context,AllSupermarketPrices.class);
				 startActivity(allSuperPr);
				 */
		    	/* productPrices=SupermarketsAndPricesStaticClass.getProductsAndPrices();
		         supermarketsNameAndAddress=SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress();
		    	 setContentView(R.layout.all_prices);
		    	 */
		    	 
		    	 productPrices=new String[SupermarketsAndPricesStaticClass.getProductsAndPrices().length][];
		         for(int i=0;i<SupermarketsAndPricesStaticClass.getProductsAndPrices().length;i++)
		         {
		         	productPrices[i]=new String[SupermarketsAndPricesStaticClass.getProductsAndPrices()[i].length-1];
		         	for(int j=0;j<SupermarketsAndPricesStaticClass.getProductsAndPrices()[i].length-1;j++)
		             {
		         		productPrices[i][j]=SupermarketsAndPricesStaticClass.getProductsAndPrices()[i][j];
		             }
		         }
		        
		         supermarketsNameAndAddress=new String[SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress().length];
		         for(int i=0;i<SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress().length;i++)
		         {
		         	supermarketsNameAndAddress[i]=SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress()[i];
		         }
		         supermarketsNameAndAddress=SupermarketsAndPricesStaticClass.getSupermarketsNamesAndAddress();
		         
		         //setContentView(R.layout.all_prices);
		         vf.setDisplayedChild(1);
		         currentViewDisplay="prices";
		         theExList=(ExpandableListView)findViewById(R.id.expandablelist1);
		         // Set up our adapter
		         mAdapter = new MyExpandableListAdapter();
		         theExList.setAdapter(mAdapter);
		    	 break;
	      }
	}
	
	
	 public class MyExpandableListAdapter extends BaseExpandableListAdapter
	    {
	        public Object getChild(int groupPosition, int childPosition) {
	            return productPrices[groupPosition][childPosition];
	        }

	        public long getChildId(int groupPosition, int childPosition) {
	            return childPosition;
	        }

	        public int getChildrenCount(int groupPosition) {
	            return productPrices[groupPosition].length;
	        }

	        public TextView getGenericViewGroups() {
	            // Layout parameters for the ExpandableListView
	            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

	            TextView textView = new TextView(SuperMarketInMap.this);
	            textView.setLayoutParams(lp);
	            // Center the text vertically
	            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
	            // Set the text starting position
	            textView.setTextColor(res.getColor(R.color.expandable_text_color_groups));
	            textView.setBackgroundColor(res.getColor(R.color.blue_text));
	            textView.setPadding(36, 0, 0, 0);
	            return textView;
	        }
	        
	        public TextView getGenericViewChilds() {
	            // Layout parameters for the ExpandableListView
	            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

	            TextView textView = new TextView(SuperMarketInMap.this);
	            textView.setLayoutParams(lp);
	            // Center the text vertically
	            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
	            // Set the text starting position
	            textView.setTextColor(res.getColor(R.color.expandable_text_color_childs));
	            textView.setBackgroundColor(res.getColor(R.color.expandable_childs));
	            textView.setPadding(36, 0, 0, 0);
	            return textView;
	        }
	        
	        public View getChildView(int groupPosition, int childPosition, boolean isLastChild,View convertView, ViewGroup parent) 
	        {
	            TextView textView = getGenericViewChilds();
	            textView.setText(getChild(groupPosition, childPosition).toString());
	            return textView;
	        }

	        public Object getGroup(int groupPosition) 
	        {
	            return supermarketsNameAndAddress[groupPosition];
	        }

	        public int getGroupCount() 
	        {
	            return supermarketsNameAndAddress.length;
	        }

	        public long getGroupId(int groupPosition) 
	        {
	            return groupPosition;
	        }

	        public View getGroupView(int groupPosition, boolean isExpanded, View convertView,ViewGroup parent)
	        {
	            TextView textView = getGenericViewGroups();
	            textView.setText(getGroup(groupPosition).toString());
	            return textView;
	        }

	        public boolean isChildSelectable(int groupPosition, int childPosition) 
	        {
	            return true;
	        }

	        public boolean hasStableIds()
	        {
	            return true;
	        }

	    }
	 
	 
	 
	 
	 public class MyExpandableListAdapter1 extends BaseExpandableListAdapter
	    {
	        public Object getChild(int groupPosition, int childPosition) {
	            return superComb.combProductTotalDescriptionName[groupPosition][childPosition];
	        }

	        public long getChildId(int groupPosition, int childPosition) {
	            return childPosition;
	        }

	        public int getChildrenCount(int groupPosition) {
	            return superComb.combProductTotalDescriptionName[groupPosition].length;
	        }

	        public TextView getGenericViewGroups() {
	            // Layout parameters for the ExpandableListView
	            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

	            TextView textView = new TextView(SuperMarketInMap.this);
	            textView.setLayoutParams(lp);
	            // Center the text vertically
	            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
	            // Set the text starting position
	            textView.setTextColor(res.getColor(R.color.expandable_text_color_groups));
	            textView.setBackgroundColor(res.getColor(R.color.blue_text));
	            textView.setPadding(36, 0, 0, 0);
	            return textView;
	        }
	        
	        public TextView getGenericViewChilds() {
	            // Layout parameters for the ExpandableListView
	            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

	            TextView textView = new TextView(SuperMarketInMap.this);
	            textView.setLayoutParams(lp);
	            // Center the text vertically
	            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
	            // Set the text starting position
	            textView.setTextColor(res.getColor(R.color.expandable_text_color_childs));
	            textView.setBackgroundColor(res.getColor(R.color.expandable_childs));
	            textView.setPadding(36, 0, 0, 0);
	            return textView;
	        }
	        
	        public View getChildView(int groupPosition, int childPosition, boolean isLastChild,View convertView, ViewGroup parent) 
	        {
	            TextView textView = getGenericViewChilds();
	            textView.setText(getChild(groupPosition, childPosition).toString());
	            return textView;
	        }

	        public Object getGroup(int groupPosition) 
	        {
	            return superComb.combSuperTotalDescriptionName[groupPosition];
	        }

	        public int getGroupCount() 
	        {
	            return superComb.combSuperTotalDescriptionName.length;
	        }

	        public long getGroupId(int groupPosition) 
	        {
	            return groupPosition;
	        }

	        public View getGroupView(int groupPosition, boolean isExpanded, View convertView,ViewGroup parent)
	        {
	            TextView textView = getGenericViewGroups();
	            textView.setText(getGroup(groupPosition).toString());
	            return textView;
	        }

	        public boolean isChildSelectable(int groupPosition, int childPosition) 
	        {
	            return true;
	        }

	        public boolean hasStableIds()
	        {
	            return true;
	        }

	    }
 
	 public void onBackPressed()
	 {
		 if(currentViewDisplay.equals("prices"))
		 {
			 vf.setDisplayedChild(0);
			 currentViewDisplay=new String("map");
		 }
		 else
			 finish();
	 }
}

