package org.supermarket.gr;

import java.util.ArrayList;

/**
 * Στη κλάση αυτή εκτελείται αλγόριθμος που παράγει όλα τα ζεύγη των 
 * supermarket που έχουν βρεθεί και κατανέμει κατάλληλα τα προϊόντα
 *  της λίστας σε κάθε ζεύγος ώστε να ελαχιστοποιείται το κόστος
 */
public class SupermarketCombination 
{
	public int superNum;
	public int productNum;
	public ArrayList<String> superName;
	public ArrayList<String> productNames;
	public String productsWithPrices[][];
	
	
	/**
	 * Pinakas pou exei ti perigrafi tou veltistou syndiasmou sxetika me to kostos
	 */
	public String combSuperPrices[];
	
	
	public int totalCombinations;
	
	
	/**
	 * Pinakas pou exei tous syndyasmous supermarket 
	*p.x combSuper[0][0]=1  combSuper[0][1]=4  aytos einai o syndyasmos [0,4]
	 */
	public String combSuper[][];
	 
	/**
	 * Pinakas pou exei gia kathe syndyasmo ena string pou antiproswpeyei ta onamta twn supermarket
	 */
	public String combSuperTotalDescriptionName[];
		
	/**
	 * Pinakas pou exei gia kathe syndyasmo ena string pou antiproswpeyei ta proionta  
	 */
	public String combProductTotalDescriptionName[][];
	
	/**
	 * Exei gia kathe syndyasmo supermarket tin kalyteri katanomi proiontvn me vasi to kostos
	 */
	public String theBestCombinations[];
	
	
	/**
	 *  Exei gia kathe syndyasmo supermarket to veltisto kostos katanomis proiontwn
	 */
	public double totalCost[];
	
	public SupermarketCombination(ArrayList<String> theSupermarkets,ArrayList<String> theProductNames)
	{
		//Pinakas me ta supermarket
		superName=theSupermarkets;
		productNames=theProductNames;
		//Pinakas me ta proionta kai tis times 
		productsWithPrices =SupermarketsAndPricesStaticClass.getProductsAndPrices();
		superNum=superName.size();
		productNum=productsWithPrices[0].length;
		//productNum=productNames.size()+1;
		totalCombinations = (int) Math.pow(2, productNum-1);
		
		
	}
	
	/**
	 *  Συναρτηση παραγωγής όλων των δυνατών ζυεγών supermarket
	 */
	public void allSuperCombination()
  	{
	 	ArrayList<String> super1;
	 	ArrayList<String> super2;
	 	super1= new ArrayList<String>( );
	 	super2= new ArrayList<String>( );
  		
  		int combinationNum=0;
  		for(int i=0;i<=superNum-1;i++)
  		{
  			combinationNum=combinationNum+i;
  		}
  		
  		combProductTotalDescriptionName=new String[combinationNum][productNum-1];
  		
  		combSuper=new String[combinationNum][2];
  		combSuperTotalDescriptionName=new String[combinationNum];
  		combSuperPrices=new String[combinationNum];
  		 
  		theBestCombinations=new String[combinationNum];
  		totalCost=new double[combinationNum];
  		int counterJ=0;
  		int counterI=0;
  		
  		//Dimiorgw olous tous dynatous syndyasmous supermarket
  		for(int i=0;i<superName.size(); i++) 
  		{
  			counterJ=0;
      		for (int j=i+1; j<superName.size(); j++) 
      		{
      			
      				combSuper[counterI][0]=superName.get(i);
      				counterJ++;
      				combSuper[counterI][1]=superName.get(j);
      				counterJ=0;
      				
      				totalCost[counterI]=0.0;
      				//searchCombinations(i,j);
      				composeCombinationsOfProducts(counterI,i,j,"",productNum-1);
      				
      				combSuperTotalDescriptionName[counterI]=superName.get(i)+" / "+superName.get(j)+" /total cost = "+totalCost[counterI];
      				
      				for(int h=0;h<productNum-1;h++)
      		        {
      					if(theBestCombinations[counterI].charAt(h)=='0')
      					{
      						combProductTotalDescriptionName[counterI][h]=superName.get(i)+" /"+productNames.get(h)+" / "+SupermarketsAndPricesStaticClass.getProductPricesStatic()[i][h];
      					}
      					else if(theBestCombinations[counterI].charAt(h)=='1')
      					{
      						combProductTotalDescriptionName[counterI][h]=superName.get(j)+" /"+productNames.get(h)+" / "+SupermarketsAndPricesStaticClass.getProductPricesStatic()[j][h];
      					}
      					
      		        }
      				counterI++;
      				
      				
      		}
    	}
    	
    	//return theBestCombinations;
  	}
	
	/**
	 *  Αναδρομική συνάρτηση παραγωγής των κατανομών των προιόντων σε ζεύγος supermarket
	 */
	public void composeCombinationsOfProducts(int theCombS,int super1,int super2,String soFar, int iterations) 
	{
	    if(iterations == 0) 
	    {
	        System.out.println(soFar);
	        double semiCost=0.0;
	        
	        System.out.println("super1 = "+ super1);
        	System.out.println("super2 = "+ super2);
        	
	     //   int productBoxes[]=new int[productNum-1];
	        for(int i=0;i<productNum-1;i++)
	        {
	        	//productBoxes[i]=soFar.charAt(0);
	        	
	        	
	        	System.out.println("price 1 = "+ SupermarketsAndPricesStaticClass.getProductPricesStatic()[super1][i]);
	        	System.out.println("price 2 = "+ SupermarketsAndPricesStaticClass.getProductPricesStatic()[super2][i]);
	        	//System.out.println("soFar.charAt(0) = "+ soFar.charAt(0));
	        	//System.out.println("soFar.charAt(1) = "+ soFar.charAt(1));
	        	
	        	if(soFar.charAt(i)=='0')
	        	{
	        		double partCost=Double.parseDouble(SupermarketsAndPricesStaticClass.getProductPricesStatic()[super1][i]);
					
	        		semiCost=semiCost+partCost;
	        	}
	        	else if(soFar.charAt(i)=='1')
	        	{
	        		double partCost=Double.parseDouble(SupermarketsAndPricesStaticClass.getProductPricesStatic()[super2][i]);
					
	        		semiCost=semiCost+partCost;
	        	}
	        	
	        	System.out.println("semiCost = "+ semiCost);
	        		
	        }
	        
	        if(semiCost<totalCost[theCombS])
	        {
	        	theBestCombinations[theCombS]=soFar;
	        	totalCost[theCombS]=semiCost;
	        	//productBoxes;
	        }
	        else if(totalCost[theCombS]==0)
	        {
	        	theBestCombinations[theCombS]=soFar;
	        	totalCost[theCombS]=semiCost;
	        }
	        System.out.println("totalCost = "+ totalCost);
	        
	    }
	    else 
	    {
	    	composeCombinationsOfProducts(theCombS,super1,super2,soFar + "0", iterations - 1);
	    	composeCombinationsOfProducts(theCombS,super1,super2,soFar + "1", iterations - 1);
	    }
	}

}
