package org.supermarket.gr;

import java.io.IOException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.database.Cursor;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.View.OnClickListener;
import android.view.Gravity;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.BaseExpandableListAdapter;
import android.widget.ExpandableListAdapter;
import android.widget.ExpandableListView;
import android.widget.ExpandableListView.ExpandableListContextMenuInfo;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
/**
 * Στη UserProductLists σχεδιάζεται η λίστα με το σύνολο των αποθηκευμένων 
 * λιστών και δίνεται η δυνατότητα στον χρήστη μέσω συναρτήσεων να διαγράψει,
 *  να ενημερώσει και να δημιουργήσει λίστες και προϊόντα.
 * 
 * @return
 */
public class UserProductLists extends Activity implements OnClickListener{

    ExpandableListAdapter mAdapter;
    protected String theUserID;
    protected String upc;
    public static final String USER_STORED = "User_stored";
    protected String[] groups;
    protected String[] groupsIDS;
    protected String[] barcodeIDS;
    protected String[][] children;
	protected Resources res;
	protected ProgressDialog dialogDB;
	protected String barcodeDetails[];
	int currentGroupPosition;
	private final int SET_QUANTITIES_REQUEST_CODE=120;
	private final int ADD_BARCODE_REQUEST_CODE=121;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.user_lists);

        TextView addShoppingTxt = (TextView) findViewById(R.id.add_shopping_list_id_txt);
        addShoppingTxt.setOnClickListener(this);
	    
        ImageView addShoppingList  = (ImageView) findViewById(R.id.add_shopping_list_id);
        addShoppingList.setOnClickListener(this);
        
        res = getResources();
        dialogDB = new ProgressDialog(this);
        
        SharedPreferences current_session = getSharedPreferences(USER_STORED, 0);
        theUserID=new String();
    	theUserID = current_session.getString("user_id", "nill");
    	
    	
    	retrieveItemsToPresent();
    	
    	
    }
    
    public void retrieveItemsToPresent()
    {
    	DatabaseCommunication ed=new DatabaseCommunication(this);
    	Cursor cursor=ed.retrieveUserShoppingLists(theUserID,"Lists");
    	int rowCounts=cursor.getCount();
    	
    	 groups = new String[cursor.getCount()];
    	 groupsIDS= new String[cursor.getCount()];
    	 children=new String[cursor.getCount()][];
    	for (int i = 0; i < rowCounts; i++) 
        {
        	cursor.moveToNext();
            String listName=new String(cursor.getString(cursor.getColumnIndexOrThrow("list_name")));
            groups[i]=listName;
            
            String productListID=new String(cursor.getString(cursor.getColumnIndexOrThrow("list_id")));
            groupsIDS[i]=productListID;
            Cursor cursor1=ed.retrieveProductsOfShoppingList(productListID);
            children[i]=new String[cursor1.getCount()];
            barcodeIDS=new String[cursor1.getCount()];
            //Log.v("TAG","group with i = "+i+"   -> "+groups[i]);
            //Log.v("TAG","count = "   +cursor1.getCount());
            for (int j = 0; j < cursor1.getCount();j++) 
            {
            	cursor1.moveToNext();
            	String productName=new String(cursor1.getString(cursor1.getColumnIndexOrThrow("pname")));
            	String barcodeID=new String(cursor1.getString(cursor1.getColumnIndexOrThrow("barcode")));
            	barcodeIDS[j]=barcodeID;
            	children[i][j]=productName;
            	Log.v("TAG","children with i = "+i+" and with j = "+j+"   -> "+children[i][j]);
            }
            cursor1.close();
        }
    	
    	cursor.close();
    	ed.closeDB();
    	ExpandableListView theExList=(ExpandableListView)findViewById(R.id.expandablelist);
        // Set up our adapter
        mAdapter = new MyExpandableListAdapter();
        theExList.setAdapter(mAdapter);
        
        //setListAdapter(mAdapter);
        registerForContextMenu(theExList);
    }

    @Override
    public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) 
    {
        menu.setHeaderTitle("List menu");
        menu.add(0, 0, 0, "Delete list");
        menu.add(0, 1, 0, "Add product to list");
        menu.add(0, 2, 0, "Remove product from list");
    }
    
    @Override
    public boolean onContextItemSelected(MenuItem item) 
    {
        ExpandableListContextMenuInfo info = (ExpandableListContextMenuInfo) item.getMenuInfo();

        String title = ((TextView) info.targetView).getText().toString();
        
        int type = ExpandableListView.getPackedPositionType(info.packedPosition);
        if (type == ExpandableListView.PACKED_POSITION_TYPE_CHILD) 
        {
        	if(item.getItemId()==0)
        	{
        		  int groupPos = ExpandableListView.getPackedPositionGroup(info.packedPosition);
        		  int childPos = ExpandableListView.getPackedPositionChild(info.packedPosition);
        		  DatabaseCommunication ed=new DatabaseCommunication(this);
        		  ed.deleteProductFromList(groupsIDS[groupPos],barcodeIDS[childPos]);
        		 // Log.v("TAG","group ids "+groupsIDS[groupPos]);
        		  ed.closeDB();
        	  
        		  retrieveItemsToPresent();
        		  //Toast.makeText(this, title + ": Child0 " + childPos + " clicked in group " + groupPos, Toast.LENGTH_SHORT).show();
        	}
        	if(item.getItemId()==1)
        	{
        		int groupPos = ExpandableListView.getPackedPositionGroup(info.packedPosition); 
                int childPos = ExpandableListView.getPackedPositionChild(info.packedPosition); 
                currentGroupPosition=groupPos;
                IntentIntegrator integrator = new IntentIntegrator(this);
    			integrator.initiateScan();
    			
    			
               // Toast.makeText(this, title + ": Child1 " + childPos + " clicked in group " + groupPos,  Toast.LENGTH_SHORT).show();
        	}
        	else if(item.getItemId()==2)
        	{
        		int groupPos = ExpandableListView.getPackedPositionGroup(info.packedPosition);
      		  	int childPos = ExpandableListView.getPackedPositionChild(info.packedPosition);
      		  	DatabaseCommunication ed=new DatabaseCommunication(this);
      		  	ed.deleteProductFromList(groupsIDS[groupPos],barcodeIDS[childPos]);
      		  	// Log.v("TAG","group ids "+groupsIDS[groupPos]);
      		  	ed.closeDB();
      		  retrieveItemsToPresent();
        	}
           
            return true;
        } 
        else if (type == ExpandableListView.PACKED_POSITION_TYPE_GROUP) 
        {
        	if(item.getItemId()==0)
        	{
        		int groupPos = ExpandableListView.getPackedPositionGroup(info.packedPosition);
        		Log.v("TAG","groupPos "+groupPos);
        		int childPos = ExpandableListView.getPackedPositionChild(info.packedPosition);
        		Log.v("TAG","childPos "+childPos);
        		Log.v("TAG","group ids "+groupsIDS[groupPos]);
        		DatabaseCommunication ed=new DatabaseCommunication(this);
      		  	ed.deleteProductList(groupsIDS[groupPos]);
      		  	 
      		  	ed.closeDB();
      		  retrieveItemsToPresent();
        		// int groupPos = ExpandableListView.getPackedPositionGroup(info.packedPosition); 
                // int childPos = ExpandableListView.getPackedPositionChild(info.packedPosition); 
                // Toast.makeText(this, title + ": Child0 " + childPos + " clicked in group " + groupPos, Toast.LENGTH_SHORT).show();
        	}
        	if(item.getItemId()==1)
        	{
        		int groupPos = ExpandableListView.getPackedPositionGroup(info.packedPosition); 
                int childPos = ExpandableListView.getPackedPositionChild(info.packedPosition); 
                Log.v("TAG","group ids "+groupsIDS[groupPos]);
                currentGroupPosition=groupPos;
                IntentIntegrator integrator = new IntentIntegrator(this);
    			integrator.initiateScan();
    			
              //  Toast.makeText(this, title + ": Child1 " + childPos + " clicked in group " + groupPos,Toast.LENGTH_SHORT).show();
        	}
        	else if(item.getItemId()==2)
        	{
        		
        	}
           
            return true;
        }
        
        return false;
    }

    /**
     * A simple adapter which maintains an ArrayList of photo resource Ids. 
     * Each photo is displayed as an image. This adapter supports clearing the
     * list of photos and adding a new photo.
     *
     */
    public class MyExpandableListAdapter extends BaseExpandableListAdapter
    {
        public Object getChild(int groupPosition, int childPosition) {
            return children[groupPosition][childPosition];
        }

        public long getChildId(int groupPosition, int childPosition) {
            return childPosition;
        }

        public int getChildrenCount(int groupPosition) {
            return children[groupPosition].length;
        }

        public TextView getGenericViewGroups() {
            // Layout parameters for the ExpandableListView
            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

            TextView textView = new TextView(UserProductLists.this);
            textView.setLayoutParams(lp);
            // Center the text vertically
            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
            // Set the text starting position
            textView.setTextColor(res.getColor(R.color.expandable_text_color_groups));
            textView.setBackgroundColor(res.getColor(R.color.blue_text));
            textView.setPadding(36, 0, 0, 0);
            return textView;
        }
        
        public TextView getGenericViewChilds() {
            // Layout parameters for the ExpandableListView
            AbsListView.LayoutParams lp = new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, 64);

            TextView textView = new TextView(UserProductLists.this);
            textView.setLayoutParams(lp);
            // Center the text vertically
            textView.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
            // Set the text starting position
            textView.setTextColor(res.getColor(R.color.expandable_text_color_childs));
            textView.setBackgroundColor(res.getColor(R.color.expandable_childs));
            textView.setPadding(36, 0, 0, 0);
            return textView;
        }
        
        public View getChildView(int groupPosition, int childPosition, boolean isLastChild,View convertView, ViewGroup parent) 
        {
            TextView textView = getGenericViewChilds();
            textView.setText(getChild(groupPosition, childPosition).toString());
            return textView;
        }

        public Object getGroup(int groupPosition) 
        {
            return groups[groupPosition];
        }

        public int getGroupCount() 
        {
            return groups.length;
        }

        public long getGroupId(int groupPosition) 
        {
            return groupPosition;
        }

        public View getGroupView(int groupPosition, boolean isExpanded, View convertView,ViewGroup parent)
        {
            TextView textView = getGenericViewGroups();
            textView.setText(getGroup(groupPosition).toString());
            return textView;
        }

        public boolean isChildSelectable(int groupPosition, int childPosition) 
        {
            return true;
        }

        public boolean hasStableIds()
        {
            return true;
        }

    }

    public void onClick(View v)
    {
    	switch(v.getId())
    	{
    		case R.id.add_shopping_list_id:
    			Intent newList = new Intent(getApplicationContext(),NewShoppingList.class);
    			startActivity(newList);
				break;
    		case R.id.add_shopping_list_id_txt:
    			Intent newList1 = new Intent(getApplicationContext(),NewShoppingList.class);
    			startActivity(newList1);
				break;
    	}
    }
    
    @Override
    protected void onResume() 
    {
        super.onResume();
        retrieveItemsToPresent();
        // The activity has become visible (it is now "resumed").
    }
    
    public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{
		  switch (requestCode) 
	        {
		        case ADD_BARCODE_REQUEST_CODE:
		        	if(resultCode == RESULT_OK) 
					{
			        	Intent quantities = new Intent(this,QuantitiesOfProductInList.class);
			        	quantities.putExtra("barcodescanned",upc);
			        	quantities.putExtra("origin","list");
					    startActivityForResult(quantities,SET_QUANTITIES_REQUEST_CODE);
			        }
			        else
			        	Toast.makeText(this,R.string.edit_barcode_fields_p,Toast.LENGTH_SHORT).show();
		        	break;
		        case SET_QUANTITIES_REQUEST_CODE: 
		        	if(resultCode == RESULT_OK) 
					{
		        		Bundle extras = intent.getExtras();
		    	        if(extras != null)
		    	        {
		    	        	DatabaseCommunication ed=new DatabaseCommunication(this);
			   			 	int barcodeInt=Integer.parseInt(groupsIDS[currentGroupPosition]);
			   			 	ed.addOneProductToUserList(barcodeInt,upc,extras.getString("quantityKey"));
			   			 	ed.closeDB();
		    	        	//barcodesOfTheListQuantity.add(extras.getString("quantityKey"));
		    	        }
		    	        else
		    	        {
		    	        	DatabaseCommunication ed=new DatabaseCommunication(this);
			   			 	int barcodeInt=Integer.parseInt(groupsIDS[currentGroupPosition]);
			   			 	ed.addOneProductToUserList(barcodeInt,upc,"1");
			   			 	ed.closeDB();
		    	        }
			        }
			        else
			        {
			        	DatabaseCommunication ed=new DatabaseCommunication(this);
		   			 	int barcodeInt=Integer.parseInt(groupsIDS[currentGroupPosition]);
		   			 	ed.addOneProductToUserList(barcodeInt,upc,"1");
		   			 	ed.closeDB();
			        }
		        	retrieveItemsToPresent();
		        	break;
		        default:
		        	IntentResult scanResult = IntentIntegrator.parseActivityResult(requestCode, resultCode, intent);
			  		  if (scanResult != null) 
			  		  {
			  			  upc = scanResult.getContents();
			  			  			//validBarcode=true;
			  					  if(resultCode == RESULT_OK) 
			  					  {
			  						  BarcodeExistsInDB task = new BarcodeExistsInDB(this,upc,"UserProductLists");
			  						  task.execute(new String[] { "" });
			  					  }
			  					  else if(resultCode == RESULT_CANCELED)
			  					  {
			  					  }
			  		  }
					  break;
	        }
	}
   
}